/* WindowIcon.c generated by valac 0.56.3, the Vala compiler
 * generated from WindowIcon.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "gala.h"
#include <meta/window.h>
#include <glib.h>
#include <libbamf/libbamf.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <clutter-gtk/clutter-gtk.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

enum  {
	GALA_WINDOW_ICON_0_PROPERTY,
	GALA_WINDOW_ICON_WINDOW_PROPERTY,
	GALA_WINDOW_ICON_ICON_SIZE_PROPERTY,
	GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY,
	GALA_WINDOW_ICON_NUM_PROPERTIES
};
static GParamSpec* gala_window_icon_properties[GALA_WINDOW_ICON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GalaWindowIconPrivate {
	MetaWindow* _window;
	gint _icon_size;
	gboolean _destroy_on_unmanaged;
	gboolean loaded;
	guint32 xid;
};

static gint GalaWindowIcon_private_offset;
static gpointer gala_window_icon_parent_class = NULL;
static BamfMatcher* gala_window_icon_matcher;
static BamfMatcher* gala_window_icon_matcher = NULL;

static void gala_window_icon_retry_load (GalaWindowIcon* self,
                                  BamfView* view);
static void _gala_window_icon_retry_load_bamf_matcher_view_opened (BamfMatcher* _sender,
                                                            BamfView* object,
                                                            gpointer self);
static void gala_window_icon_update_texture (GalaWindowIcon* self,
                                      gboolean initial);
static void gala_window_icon_unmanaged (GalaWindowIcon* self,
                                 MetaWindow* window);
static void _gala_window_icon_unmanaged_meta_window_unmanaged (MetaWindow* _sender,
                                                        gpointer self);
static GObject * gala_window_icon_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void gala_window_icon_finalize (GObject * obj);
static GType gala_window_icon_get_type_once (void);
static void _vala_gala_window_icon_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_gala_window_icon_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_window_icon_get_instance_private (GalaWindowIcon* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowIcon_private_offset);
}

static void
_gala_window_icon_retry_load_bamf_matcher_view_opened (BamfMatcher* _sender,
                                                       BamfView* object,
                                                       gpointer self)
{
#line 113 "WindowIcon.vala"
	gala_window_icon_retry_load ((GalaWindowIcon*) self, object);
#line 100 "WindowIcon.c"
}

/**
 * Creates a new WindowIcon
 *
 * @param window               The window for which to create the icon
 * @param icon_size            The size of the icon in pixels
 * @param destroy_on_unmanaged see destroy_on_unmanaged property
 */
GalaWindowIcon*
gala_window_icon_construct (GType object_type,
                            MetaWindow* window,
                            gint icon_size,
                            gboolean destroy_on_unmanaged)
{
	GalaWindowIcon * self = NULL;
#line 73 "WindowIcon.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 75 "WindowIcon.vala"
	self = (GalaWindowIcon*) g_object_new (object_type, "window", window, "icon-size", icon_size, "destroy-on-unmanaged", destroy_on_unmanaged, NULL);
#line 73 "WindowIcon.vala"
	return self;
#line 123 "WindowIcon.c"
}

GalaWindowIcon*
gala_window_icon_new (MetaWindow* window,
                      gint icon_size,
                      gboolean destroy_on_unmanaged)
{
#line 73 "WindowIcon.vala"
	return gala_window_icon_construct (GALA_TYPE_WINDOW_ICON, window, icon_size, destroy_on_unmanaged);
#line 133 "WindowIcon.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 118 "WindowIcon.vala"
	return self ? g_object_ref (self) : NULL;
#line 141 "WindowIcon.c"
}

static void
gala_window_icon_retry_load (GalaWindowIcon* self,
                             BamfView* view)
{
	BamfApplication* app = NULL;
	BamfMatcher* _tmp0_;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	BamfMatcher* _tmp3_;
	guint _tmp4_;
	BamfApplication* _tmp5_;
#line 116 "WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 116 "WindowIcon.vala"
	g_return_if_fail (view != NULL);
#line 118 "WindowIcon.vala"
	_tmp0_ = gala_window_icon_matcher;
#line 118 "WindowIcon.vala"
	_tmp1_ = bamf_matcher_get_application_for_xid (_tmp0_, self->priv->xid);
#line 118 "WindowIcon.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 118 "WindowIcon.vala"
	app = _tmp2_;
#line 121 "WindowIcon.vala"
	self->priv->loaded = TRUE;
#line 122 "WindowIcon.vala"
	_tmp3_ = gala_window_icon_matcher;
#line 122 "WindowIcon.vala"
	g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp4_, NULL, FALSE);
#line 122 "WindowIcon.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self);
#line 124 "WindowIcon.vala"
	_tmp5_ = app;
#line 124 "WindowIcon.vala"
	if (_tmp5_ == NULL) {
#line 125 "WindowIcon.vala"
		_g_object_unref0 (app);
#line 125 "WindowIcon.vala"
		return;
#line 183 "WindowIcon.c"
	}
#line 127 "WindowIcon.vala"
	gala_window_icon_update_texture (self, FALSE);
#line 116 "WindowIcon.vala"
	_g_object_unref0 (app);
#line 189 "WindowIcon.c"
}

static void
gala_window_icon_update_texture (GalaWindowIcon* self,
                                 gboolean initial)
{
	GdkPixbuf* pixbuf = NULL;
	MetaWindow* _tmp0_;
	gint _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 130 "WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 132 "WindowIcon.vala"
	_tmp0_ = self->priv->_window;
#line 132 "WindowIcon.vala"
	_tmp1_ = self->priv->_icon_size;
#line 132 "WindowIcon.vala"
	_tmp2_ = gala_utils_get_icon_for_window (_tmp0_, _tmp1_, !initial);
#line 132 "WindowIcon.vala"
	pixbuf = _tmp2_;
#line 211 "WindowIcon.c"
	{
#line 135 "WindowIcon.vala"
		gtk_clutter_texture_set_from_pixbuf ((GtkClutterTexture*) self, pixbuf, &_inner_error0_);
#line 135 "WindowIcon.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "WindowIcon.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 134 "WindowIcon.vala"
		g_clear_error (&_inner_error0_);
#line 226 "WindowIcon.c"
	}
	__finally0:
#line 134 "WindowIcon.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "WindowIcon.vala"
		_g_object_unref0 (pixbuf);
#line 134 "WindowIcon.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "WindowIcon.vala"
		g_clear_error (&_inner_error0_);
#line 134 "WindowIcon.vala"
		return;
#line 239 "WindowIcon.c"
	}
#line 130 "WindowIcon.vala"
	_g_object_unref0 (pixbuf);
#line 243 "WindowIcon.c"
}

static void
gala_window_icon_unmanaged (GalaWindowIcon* self,
                            MetaWindow* window)
{
#line 139 "WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 139 "WindowIcon.vala"
	g_return_if_fail (window != NULL);
#line 141 "WindowIcon.vala"
	clutter_actor_destroy ((ClutterActor*) self);
#line 256 "WindowIcon.c"
}

MetaWindow*
gala_window_icon_get_window (GalaWindowIcon* self)
{
	MetaWindow* result;
	MetaWindow* _tmp0_;
#line 39 "WindowIcon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "WindowIcon.vala"
	_tmp0_ = self->priv->_window;
#line 39 "WindowIcon.vala"
	result = _tmp0_;
#line 39 "WindowIcon.vala"
	return result;
#line 272 "WindowIcon.c"
}

static void
gala_window_icon_set_window (GalaWindowIcon* self,
                             MetaWindow* value)
{
	MetaWindow* old_value;
#line 39 "WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 39 "WindowIcon.vala"
	old_value = gala_window_icon_get_window (self);
#line 39 "WindowIcon.vala"
	if (old_value != value) {
#line 286 "WindowIcon.c"
		MetaWindow* _tmp0_;
#line 39 "WindowIcon.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "WindowIcon.vala"
		_g_object_unref0 (self->priv->_window);
#line 39 "WindowIcon.vala"
		self->priv->_window = _tmp0_;
#line 39 "WindowIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_WINDOW_PROPERTY]);
#line 296 "WindowIcon.c"
	}
}

gint
gala_window_icon_get_icon_size (GalaWindowIcon* self)
{
	gint result;
#line 40 "WindowIcon.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "WindowIcon.vala"
	result = self->priv->_icon_size;
#line 40 "WindowIcon.vala"
	return result;
#line 310 "WindowIcon.c"
}

static void
gala_window_icon_set_icon_size (GalaWindowIcon* self,
                                gint value)
{
	gint old_value;
#line 40 "WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 40 "WindowIcon.vala"
	old_value = gala_window_icon_get_icon_size (self);
#line 40 "WindowIcon.vala"
	if (old_value != value) {
#line 40 "WindowIcon.vala"
		self->priv->_icon_size = value;
#line 40 "WindowIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_ICON_SIZE_PROPERTY]);
#line 328 "WindowIcon.c"
	}
}

gboolean
gala_window_icon_get_destroy_on_unmanaged (GalaWindowIcon* self)
{
	gboolean result;
#line 47 "WindowIcon.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "WindowIcon.vala"
	result = self->priv->_destroy_on_unmanaged;
#line 48 "WindowIcon.vala"
	return result;
#line 342 "WindowIcon.c"
}

static void
_gala_window_icon_unmanaged_meta_window_unmanaged (MetaWindow* _sender,
                                                   gpointer self)
{
#line 56 "WindowIcon.vala"
	gala_window_icon_unmanaged ((GalaWindowIcon*) self, _sender);
#line 351 "WindowIcon.c"
}

void
gala_window_icon_set_destroy_on_unmanaged (GalaWindowIcon* self,
                                           gboolean value)
{
#line 50 "WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 51 "WindowIcon.vala"
	if (self->priv->_destroy_on_unmanaged == value) {
#line 52 "WindowIcon.vala"
		return;
#line 364 "WindowIcon.c"
	}
#line 54 "WindowIcon.vala"
	self->priv->_destroy_on_unmanaged = value;
#line 55 "WindowIcon.vala"
	if (self->priv->_destroy_on_unmanaged) {
#line 370 "WindowIcon.c"
		MetaWindow* _tmp0_;
#line 56 "WindowIcon.vala"
		_tmp0_ = self->priv->_window;
#line 56 "WindowIcon.vala"
		g_signal_connect_object (_tmp0_, "unmanaged", (GCallback) _gala_window_icon_unmanaged_meta_window_unmanaged, self, 0);
#line 376 "WindowIcon.c"
	} else {
		MetaWindow* _tmp1_;
		guint _tmp2_;
#line 58 "WindowIcon.vala"
		_tmp1_ = self->priv->_window;
#line 58 "WindowIcon.vala"
		g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp2_, NULL, FALSE);
#line 58 "WindowIcon.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_icon_unmanaged_meta_window_unmanaged, self);
#line 386 "WindowIcon.c"
	}
#line 50 "WindowIcon.vala"
	g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY]);
#line 390 "WindowIcon.c"
}

static GObject *
gala_window_icon_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowIcon * self;
	gint _tmp0_;
	gint _tmp1_;
	MetaWindow* _tmp2_;
	gchar* flatpak_appid = NULL;
	MetaWindow* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp12_;
	BamfApplication* _tmp13_;
	BamfApplication* _tmp14_;
	BamfApplication* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 81 "WindowIcon.vala"
	parent_class = G_OBJECT_CLASS (gala_window_icon_parent_class);
#line 81 "WindowIcon.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 81 "WindowIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 83 "WindowIcon.vala"
	_tmp0_ = self->priv->_icon_size;
#line 83 "WindowIcon.vala"
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) _tmp0_);
#line 84 "WindowIcon.vala"
	_tmp1_ = self->priv->_icon_size;
#line 84 "WindowIcon.vala"
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) _tmp1_);
#line 85 "WindowIcon.vala"
	_tmp2_ = self->priv->_window;
#line 85 "WindowIcon.vala"
	self->priv->xid = (guint32) meta_window_get_xwindow (_tmp2_);
#line 87 "WindowIcon.vala"
	_tmp3_ = self->priv->_window;
#line 87 "WindowIcon.vala"
	_tmp4_ = meta_window_get_flatpak_appid (_tmp3_);
#line 87 "WindowIcon.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 87 "WindowIcon.vala"
	flatpak_appid = _tmp5_;
#line 88 "WindowIcon.vala"
	_tmp6_ = flatpak_appid;
#line 88 "WindowIcon.vala"
	if (_tmp6_ != NULL) {
#line 445 "WindowIcon.c"
		FILE* _tmp7_;
		GdkPixbuf* pixbuf = NULL;
		const gchar* _tmp8_;
		gint _tmp9_;
		GdkPixbuf* _tmp10_;
#line 89 "WindowIcon.vala"
		_tmp7_ = stderr;
#line 89 "WindowIcon.vala"
		fprintf (_tmp7_, "%s: flatpak_appid\n", "");
#line 90 "WindowIcon.vala"
		_tmp8_ = flatpak_appid;
#line 90 "WindowIcon.vala"
		_tmp9_ = self->priv->_icon_size;
#line 90 "WindowIcon.vala"
		_tmp10_ = gala_utils_get_icon_for_flatpak_app (_tmp8_, _tmp9_);
#line 90 "WindowIcon.vala"
		pixbuf = _tmp10_;
#line 463 "WindowIcon.c"
		{
			GdkPixbuf* _tmp11_;
#line 92 "WindowIcon.vala"
			_tmp11_ = pixbuf;
#line 92 "WindowIcon.vala"
			gtk_clutter_texture_set_from_pixbuf ((GtkClutterTexture*) self, _tmp11_, &_inner_error0_);
#line 92 "WindowIcon.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 472 "WindowIcon.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 91 "WindowIcon.vala"
			g_clear_error (&_inner_error0_);
#line 481 "WindowIcon.c"
		}
		__finally0:
#line 91 "WindowIcon.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "WindowIcon.vala"
			_g_object_unref0 (pixbuf);
#line 91 "WindowIcon.vala"
			_g_free0 (flatpak_appid);
#line 91 "WindowIcon.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "WindowIcon.vala"
			g_clear_error (&_inner_error0_);
#line 494 "WindowIcon.c"
		}
#line 94 "WindowIcon.vala"
		self->priv->loaded = TRUE;
#line 95 "WindowIcon.vala"
		_g_object_unref0 (pixbuf);
#line 95 "WindowIcon.vala"
		_g_free0 (flatpak_appid);
#line 95 "WindowIcon.vala"
		return obj;
#line 504 "WindowIcon.c"
	}
#line 101 "WindowIcon.vala"
	_tmp12_ = gala_window_icon_matcher;
#line 101 "WindowIcon.vala"
	_tmp13_ = bamf_matcher_get_application_for_xid (_tmp12_, self->priv->xid);
#line 101 "WindowIcon.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 101 "WindowIcon.vala"
	app = _tmp14_;
#line 102 "WindowIcon.vala"
	_tmp15_ = app;
#line 102 "WindowIcon.vala"
	if (_tmp15_ == NULL) {
#line 518 "WindowIcon.c"
		BamfMatcher* _tmp16_;
#line 103 "WindowIcon.vala"
		_tmp16_ = gala_window_icon_matcher;
#line 103 "WindowIcon.vala"
		g_signal_connect_object (_tmp16_, "view-opened", (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self, 0);
#line 524 "WindowIcon.c"
	} else {
#line 105 "WindowIcon.vala"
		self->priv->loaded = TRUE;
#line 528 "WindowIcon.c"
	}
#line 107 "WindowIcon.vala"
	gala_window_icon_update_texture (self, TRUE);
#line 81 "WindowIcon.vala"
	_g_object_unref0 (app);
#line 81 "WindowIcon.vala"
	_g_free0 (flatpak_appid);
#line 81 "WindowIcon.vala"
	return obj;
#line 538 "WindowIcon.c"
}

static void
gala_window_icon_class_init (GalaWindowIconClass * klass,
                             gpointer klass_data)
{
	BamfMatcher* _tmp0_;
#line 25 "WindowIcon.vala"
	gala_window_icon_parent_class = g_type_class_peek_parent (klass);
#line 25 "WindowIcon.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowIcon_private_offset);
#line 25 "WindowIcon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_icon_get_property;
#line 25 "WindowIcon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_icon_set_property;
#line 25 "WindowIcon.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_icon_constructor;
#line 25 "WindowIcon.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_icon_finalize;
#line 25 "WindowIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_WINDOW_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "WindowIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_ICON_SIZE_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 562 "WindowIcon.c"
	/**
	 * If set to true, the SafeWindowClone will destroy itself when the connected
	 * window is unmanaged
	 */
#line 25 "WindowIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY, gala_window_icon_properties[GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY] = g_param_spec_boolean ("destroy-on-unmanaged", "destroy-on-unmanaged", "destroy-on-unmanaged", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "WindowIcon.vala"
	_tmp0_ = bamf_matcher_get_default ();
#line 36 "WindowIcon.vala"
	_g_object_unref0 (gala_window_icon_matcher);
#line 36 "WindowIcon.vala"
	gala_window_icon_matcher = _tmp0_;
#line 575 "WindowIcon.c"
}

static void
gala_window_icon_instance_init (GalaWindowIcon * self,
                                gpointer klass)
{
#line 25 "WindowIcon.vala"
	self->priv = gala_window_icon_get_instance_private (self);
#line 62 "WindowIcon.vala"
	self->priv->_destroy_on_unmanaged = FALSE;
#line 63 "WindowIcon.vala"
	self->priv->loaded = FALSE;
#line 588 "WindowIcon.c"
}

static void
gala_window_icon_finalize (GObject * obj)
{
	GalaWindowIcon * self;
#line 25 "WindowIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 112 "WindowIcon.vala"
	if (!self->priv->loaded) {
#line 599 "WindowIcon.c"
		BamfMatcher* _tmp0_;
		guint _tmp1_;
#line 113 "WindowIcon.vala"
		_tmp0_ = gala_window_icon_matcher;
#line 113 "WindowIcon.vala"
		g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp1_, NULL, FALSE);
#line 113 "WindowIcon.vala"
		g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self);
#line 608 "WindowIcon.c"
	}
#line 39 "WindowIcon.vala"
	_g_object_unref0 (self->priv->_window);
#line 25 "WindowIcon.vala"
	G_OBJECT_CLASS (gala_window_icon_parent_class)->finalize (obj);
#line 614 "WindowIcon.c"
}

/**
 * Creates a new GtkClutterTexture with an icon for the window at the given size.
 * This is recommended way to grab an icon for a window as this method will make
 * sure the icon is updated if it becomes available at a later point.
 */
static GType
gala_window_icon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowIcon), 0, (GInstanceInitFunc) gala_window_icon_instance_init, NULL };
	GType gala_window_icon_type_id;
	gala_window_icon_type_id = g_type_register_static (gtk_clutter_texture_get_type (), "GalaWindowIcon", &g_define_type_info, 0);
	GalaWindowIcon_private_offset = g_type_add_instance_private (gala_window_icon_type_id, sizeof (GalaWindowIconPrivate));
	return gala_window_icon_type_id;
}

GType
gala_window_icon_get_type (void)
{
	static volatile gsize gala_window_icon_type_id__once = 0;
	if (g_once_init_enter (&gala_window_icon_type_id__once)) {
		GType gala_window_icon_type_id;
		gala_window_icon_type_id = gala_window_icon_get_type_once ();
		g_once_init_leave (&gala_window_icon_type_id__once, gala_window_icon_type_id);
	}
	return gala_window_icon_type_id__once;
}

static void
_vala_gala_window_icon_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 25 "WindowIcon.vala"
	switch (property_id) {
#line 25 "WindowIcon.vala"
		case GALA_WINDOW_ICON_WINDOW_PROPERTY:
#line 25 "WindowIcon.vala"
		g_value_set_object (value, gala_window_icon_get_window (self));
#line 25 "WindowIcon.vala"
		break;
#line 25 "WindowIcon.vala"
		case GALA_WINDOW_ICON_ICON_SIZE_PROPERTY:
#line 25 "WindowIcon.vala"
		g_value_set_int (value, gala_window_icon_get_icon_size (self));
#line 25 "WindowIcon.vala"
		break;
#line 25 "WindowIcon.vala"
		case GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY:
#line 25 "WindowIcon.vala"
		g_value_set_boolean (value, gala_window_icon_get_destroy_on_unmanaged (self));
#line 25 "WindowIcon.vala"
		break;
#line 672 "WindowIcon.c"
		default:
#line 25 "WindowIcon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "WindowIcon.vala"
		break;
#line 678 "WindowIcon.c"
	}
}

static void
_vala_gala_window_icon_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 25 "WindowIcon.vala"
	switch (property_id) {
#line 25 "WindowIcon.vala"
		case GALA_WINDOW_ICON_WINDOW_PROPERTY:
#line 25 "WindowIcon.vala"
		gala_window_icon_set_window (self, g_value_get_object (value));
#line 25 "WindowIcon.vala"
		break;
#line 25 "WindowIcon.vala"
		case GALA_WINDOW_ICON_ICON_SIZE_PROPERTY:
#line 25 "WindowIcon.vala"
		gala_window_icon_set_icon_size (self, g_value_get_int (value));
#line 25 "WindowIcon.vala"
		break;
#line 25 "WindowIcon.vala"
		case GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED_PROPERTY:
#line 25 "WindowIcon.vala"
		gala_window_icon_set_destroy_on_unmanaged (self, g_value_get_boolean (value));
#line 25 "WindowIcon.vala"
		break;
#line 710 "WindowIcon.c"
		default:
#line 25 "WindowIcon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "WindowIcon.vala"
		break;
#line 716 "WindowIcon.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

