/* PluginManager.c generated by valac 0.56.3, the Vala compiler
 * generated from PluginManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <X11/Xlib.h>
#include <stdlib.h>
#include <string.h>
#include "gala.h"
#include <gio/gio.h>
#include <gee.h>
#include <gmodule.h>
#include "config.h"
#include <meta/boxes.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef void (*GalaRegisterPluginFunction) (GalaPluginInfo* result, gpointer user_data);

#define GALA_TYPE_PLUGIN_MANAGER (gala_plugin_manager_get_type ())
#define GALA_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager))
#define GALA_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))
#define GALA_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))

typedef struct _GalaPluginManager GalaPluginManager;
typedef struct _GalaPluginManagerClass GalaPluginManagerClass;
typedef struct _GalaPluginManagerPrivate GalaPluginManagerPrivate;
enum  {
	GALA_PLUGIN_MANAGER_0_PROPERTY,
	GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY,
	GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY,
	GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER_PROPERTY,
	GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY,
	GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER_PROPERTY,
	GALA_PLUGIN_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
#define __vala_GalaPluginInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_GalaPluginInfo_free (var), NULL)))
typedef struct _Block4Data Block4Data;
enum  {
	GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL,
	GALA_PLUGIN_MANAGER_NUM_SIGNALS
};
static guint gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_NUM_SIGNALS] = {0};

struct _GalaPluginManager {
	GObject parent_instance;
	GalaPluginManagerPrivate * priv;
};

struct _GalaPluginManagerClass {
	GObjectClass parent_class;
};

struct _GalaPluginManagerPrivate {
	gboolean _initialized;
	XRectangle* _regions;
	gint _regions_length1;
	gint __regions_size_;
	gchar* _window_switcher_provider;
	gchar* _desktop_provider;
	gchar* _window_overview_provider;
	gchar* _workspace_view_provider;
	GHashTable* plugins;
	GFile* plugin_dir;
	GalaWindowManager* wm;
	GeeLinkedList* load_later_plugins;
};

struct _Block4Data {
	int _ref_count_;
	GalaPluginManager* self;
	XRectangle* regions;
	gint regions_length1;
	gint _regions_size_;
};

static gint GalaPluginManager_private_offset;
static gpointer gala_plugin_manager_parent_class = NULL;
static GalaPluginManager* gala_plugin_manager_instance;
static GalaPluginManager* gala_plugin_manager_instance = NULL;

VALA_EXTERN GType gala_plugin_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPluginManager, g_object_unref)
VALA_EXTERN GalaPluginManager* gala_plugin_manager_get_default (void);
static GalaPluginManager* gala_plugin_manager_new (void);
static GalaPluginManager* gala_plugin_manager_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static GalaPluginInfo* _gala_plugin_info_dup (GalaPluginInfo* self);
static void _vala_GalaPluginInfo_free (GalaPluginInfo* self);
static gboolean gala_plugin_manager_load_module (GalaPluginManager* self,
                                          const gchar* plugin_name);
static void ___lambda41_ (GalaPluginManager* self,
                   GFile* file,
                   GFile* other_file,
                   GFileMonitorEvent type);
static void ____lambda41__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static gboolean gala_plugin_manager_check_provides (GalaPluginManager* self,
                                             const gchar* name,
                                             GalaPluginFunction provides);
VALA_EXTERN gboolean gala_plugin_manager_get_initialized (GalaPluginManager* self);
static void gala_plugin_manager_load_plugin_class (GalaPluginManager* self,
                                            GalaPluginInfo* info);
static void gala_plugin_manager_initialize_plugin (GalaPluginManager* self,
                                            const gchar* plugin_name,
                                            GalaPlugin* plugin);
static void gala_plugin_manager_recalculate_regions (GalaPluginManager* self);
static void _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed (GalaPlugin* _sender,
                                                                          gpointer self);
VALA_EXTERN const gchar* gala_plugin_manager_get_workspace_view_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_workspace_view_provider (GalaPluginManager* self,
                                                      const gchar* value);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_window_overview_provider (GalaPluginManager* self,
                                                       const gchar* value);
VALA_EXTERN const gchar* gala_plugin_manager_get_desktop_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_desktop_provider (GalaPluginManager* self,
                                               const gchar* value);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_window_switcher_provider (GalaPluginManager* self,
                                                       const gchar* value);
VALA_EXTERN void gala_plugin_manager_initialize (GalaPluginManager* self,
                                     GalaWindowManager* _wm);
static void _gala_plugin_manager_initialize_plugin_gh_func (gconstpointer key,
                                                     gconstpointer value,
                                                     gpointer self);
static void gala_plugin_manager_set_initialized (GalaPluginManager* self,
                                          gboolean value);
VALA_EXTERN void gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self);
VALA_EXTERN GalaPlugin* gala_plugin_manager_get_plugin (GalaPluginManager* self,
                                            const gchar* id);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda40_ (Block4Data* _data4_,
                  const gchar* name,
                  GalaPlugin* plugin);
static void _vala_array_add4 (XRectangle* * array,
                       gint* length,
                       gint* size,
                       XRectangle value);
static void ___lambda40__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void gala_plugin_manager_set_regions (GalaPluginManager* self,
                                      XRectangle* value,
                                      gint value_length1);
VALA_EXTERN XRectangle* gala_plugin_manager_get_regions (GalaPluginManager* self,
                                             gint* result_length1);
static XRectangle* _vala_array_dup2 (XRectangle* self,
                              gssize length);
static void gala_plugin_manager_finalize (GObject * obj);
static GType gala_plugin_manager_get_type_once (void);
static void _vala_gala_plugin_manager_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_gala_plugin_manager_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_plugin_manager_get_instance_private (GalaPluginManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPluginManager_private_offset);
}

GalaPluginManager*
gala_plugin_manager_get_default (void)
{
	GalaPluginManager* _tmp0_;
	GalaPluginManager* _tmp2_;
	GalaPluginManager* result;
#line 27 "PluginManager.vala"
	_tmp0_ = gala_plugin_manager_instance;
#line 27 "PluginManager.vala"
	if (_tmp0_ == NULL) {
#line 218 "PluginManager.c"
		GalaPluginManager* _tmp1_;
#line 28 "PluginManager.vala"
		_tmp1_ = gala_plugin_manager_new ();
#line 28 "PluginManager.vala"
		_g_object_unref0 (gala_plugin_manager_instance);
#line 28 "PluginManager.vala"
		gala_plugin_manager_instance = _tmp1_;
#line 226 "PluginManager.c"
	}
#line 30 "PluginManager.vala"
	_tmp2_ = gala_plugin_manager_instance;
#line 30 "PluginManager.vala"
	result = _tmp2_;
#line 30 "PluginManager.vala"
	return result;
#line 234 "PluginManager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 53 "PluginManager.vala"
	var = (g_free (var), NULL);
#line 242 "PluginManager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 53 "PluginManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 250 "PluginManager.c"
}

static GalaPluginInfo*
_gala_plugin_info_dup (GalaPluginInfo* self)
{
	GalaPluginInfo* dup;
#line 54 "PluginManager.vala"
	dup = g_new0 (GalaPluginInfo, 1);
#line 54 "PluginManager.vala"
	gala_plugin_info_copy (self, dup);
#line 54 "PluginManager.vala"
	return dup;
#line 263 "PluginManager.c"
}

static void
_vala_GalaPluginInfo_free (GalaPluginInfo* self)
{
#line 54 "PluginManager.vala"
	gala_plugin_info_destroy (self);
#line 54 "PluginManager.vala"
	g_free (self);
#line 273 "PluginManager.c"
}

static void
___lambda41_ (GalaPluginManager* self,
              GFile* file,
              GFile* other_file,
              GFileMonitorEvent type)
{
#line 78 "PluginManager.vala"
	g_return_if_fail (file != NULL);
#line 79 "PluginManager.vala"
	if (type == G_FILE_MONITOR_EVENT_CREATED) {
#line 286 "PluginManager.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 80 "PluginManager.vala"
		_tmp0_ = g_file_get_basename (file);
#line 80 "PluginManager.vala"
		_tmp1_ = _tmp0_;
#line 80 "PluginManager.vala"
		gala_plugin_manager_load_module (self, _tmp1_);
#line 80 "PluginManager.vala"
		_g_free0 (_tmp1_);
#line 297 "PluginManager.c"
	}
}

static void
____lambda41__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 78 "PluginManager.vala"
	___lambda41_ ((GalaPluginManager*) self, file, other_file, event_type);
#line 310 "PluginManager.c"
}

static GalaPluginManager*
gala_plugin_manager_construct (GType object_type)
{
	GalaPluginManager * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GeeLinkedList* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 51 "PluginManager.vala"
	self = (GalaPluginManager*) g_object_new (object_type, NULL);
#line 53 "PluginManager.vala"
	_tmp0_ = g_str_hash;
#line 53 "PluginManager.vala"
	_tmp1_ = g_str_equal;
#line 53 "PluginManager.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 53 "PluginManager.vala"
	_g_hash_table_unref0 (self->priv->plugins);
#line 53 "PluginManager.vala"
	self->priv->plugins = _tmp2_;
#line 54 "PluginManager.vala"
	_tmp3_ = gee_linked_list_new (GALA_TYPE_PLUGIN_INFO, (GBoxedCopyFunc) _gala_plugin_info_dup, (GDestroyNotify) _vala_GalaPluginInfo_free, NULL, NULL, NULL);
#line 54 "PluginManager.vala"
	_g_object_unref0 (self->priv->load_later_plugins);
#line 54 "PluginManager.vala"
	self->priv->load_later_plugins = _tmp3_;
#line 56 "PluginManager.vala"
	if (!g_module_supported ()) {
#line 57 "PluginManager.vala"
		g_warning ("PluginManager.vala:57: Modules are not supported on this platform");
#line 58 "PluginManager.vala"
		return self;
#line 348 "PluginManager.c"
	}
#line 61 "PluginManager.vala"
	_tmp4_ = g_file_new_for_path (PLUGINDIR);
#line 61 "PluginManager.vala"
	_g_object_unref0 (self->priv->plugin_dir);
#line 61 "PluginManager.vala"
	self->priv->plugin_dir = _tmp4_;
#line 62 "PluginManager.vala"
	_tmp5_ = self->priv->plugin_dir;
#line 62 "PluginManager.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 63 "PluginManager.vala"
		return self;
#line 362 "PluginManager.c"
	}
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp6_;
		GFileEnumerator* _tmp7_;
		GFileInfo* info = NULL;
#line 66 "PluginManager.vala"
		_tmp6_ = self->priv->plugin_dir;
#line 66 "PluginManager.vala"
		_tmp7_ = g_file_enumerate_children (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
#line 66 "PluginManager.vala"
		enumerator = _tmp7_;
#line 66 "PluginManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "PluginManager.c"
			goto __catch0_g_error;
		}
#line 69 "PluginManager.vala"
		while (TRUE) {
#line 382 "PluginManager.c"
			GFileInfo* _tmp8_ = NULL;
			GFileEnumerator* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			GFileInfo* _tmp12_;
			GFileInfo* _tmp13_;
			const gchar* _tmp14_;
#line 69 "PluginManager.vala"
			_tmp9_ = enumerator;
#line 69 "PluginManager.vala"
			_tmp10_ = g_file_enumerator_next_file (_tmp9_, NULL, &_inner_error0_);
#line 69 "PluginManager.vala"
			_tmp8_ = _tmp10_;
#line 69 "PluginManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "PluginManager.vala"
				_g_object_unref0 (info);
#line 69 "PluginManager.vala"
				_g_object_unref0 (enumerator);
#line 402 "PluginManager.c"
				goto __catch0_g_error;
			}
#line 69 "PluginManager.vala"
			_tmp11_ = _tmp8_;
#line 69 "PluginManager.vala"
			_tmp8_ = NULL;
#line 69 "PluginManager.vala"
			_g_object_unref0 (info);
#line 69 "PluginManager.vala"
			info = _tmp11_;
#line 69 "PluginManager.vala"
			_tmp12_ = info;
#line 69 "PluginManager.vala"
			if (!(_tmp12_ != NULL)) {
#line 69 "PluginManager.vala"
				_g_object_unref0 (_tmp8_);
#line 69 "PluginManager.vala"
				break;
#line 421 "PluginManager.c"
			}
#line 70 "PluginManager.vala"
			_tmp13_ = info;
#line 70 "PluginManager.vala"
			_tmp14_ = g_file_info_get_content_type (_tmp13_);
#line 70 "PluginManager.vala"
			if (g_strcmp0 (_tmp14_, "application/x-sharedlib") == 0) {
#line 429 "PluginManager.c"
				GFileInfo* _tmp15_;
				const gchar* _tmp16_;
#line 71 "PluginManager.vala"
				_tmp15_ = info;
#line 71 "PluginManager.vala"
				_tmp16_ = g_file_info_get_name (_tmp15_);
#line 71 "PluginManager.vala"
				gala_plugin_manager_load_module (self, _tmp16_);
#line 438 "PluginManager.c"
			}
#line 69 "PluginManager.vala"
			_g_object_unref0 (_tmp8_);
#line 442 "PluginManager.c"
		}
#line 65 "PluginManager.vala"
		_g_object_unref0 (info);
#line 65 "PluginManager.vala"
		_g_object_unref0 (enumerator);
#line 448 "PluginManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 65 "PluginManager.vala"
		e = _inner_error0_;
#line 65 "PluginManager.vala"
		_inner_error0_ = NULL;
#line 74 "PluginManager.vala"
		_tmp17_ = e;
#line 74 "PluginManager.vala"
		_tmp18_ = _tmp17_->message;
#line 74 "PluginManager.vala"
		g_warning ("PluginManager.vala:74: %s", _tmp18_);
#line 65 "PluginManager.vala"
		_g_error_free0 (e);
#line 468 "PluginManager.c"
	}
	__finally0:
#line 65 "PluginManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "PluginManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "PluginManager.vala"
		g_clear_error (&_inner_error0_);
#line 65 "PluginManager.vala"
		return NULL;
#line 479 "PluginManager.c"
	}
	{
		GFileMonitor* _tmp19_ = NULL;
		GFile* _tmp20_;
		GFileMonitor* _tmp21_;
#line 78 "PluginManager.vala"
		_tmp20_ = self->priv->plugin_dir;
#line 78 "PluginManager.vala"
		_tmp21_ = g_file_monitor_directory (_tmp20_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 78 "PluginManager.vala"
		_tmp19_ = _tmp21_;
#line 78 "PluginManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 493 "PluginManager.c"
			goto __catch1_g_error;
		}
#line 78 "PluginManager.vala"
		g_signal_connect_object (_tmp19_, "changed", (GCallback) ____lambda41__g_file_monitor_changed, self, 0);
#line 77 "PluginManager.vala"
		_g_object_unref0 (_tmp19_);
#line 500 "PluginManager.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 77 "PluginManager.vala"
		e = _inner_error0_;
#line 77 "PluginManager.vala"
		_inner_error0_ = NULL;
#line 84 "PluginManager.vala"
		_tmp22_ = e;
#line 84 "PluginManager.vala"
		_tmp23_ = _tmp22_->message;
#line 84 "PluginManager.vala"
		g_warning ("PluginManager.vala:84: %s", _tmp23_);
#line 77 "PluginManager.vala"
		_g_error_free0 (e);
#line 520 "PluginManager.c"
	}
	__finally1:
#line 77 "PluginManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "PluginManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "PluginManager.vala"
		g_clear_error (&_inner_error0_);
#line 77 "PluginManager.vala"
		return NULL;
#line 531 "PluginManager.c"
	}
#line 51 "PluginManager.vala"
	return self;
#line 535 "PluginManager.c"
}

static GalaPluginManager*
gala_plugin_manager_new (void)
{
#line 51 "PluginManager.vala"
	return gala_plugin_manager_construct (GALA_TYPE_PLUGIN_MANAGER);
#line 543 "PluginManager.c"
}

static gboolean
gala_plugin_manager_load_module (GalaPluginManager* self,
                                 const gchar* plugin_name)
{
	gchar* path = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GModule* module = NULL;
	const gchar* _tmp5_;
	GModule* _tmp6_;
	GModule* _tmp7_;
	void* function = NULL;
	GModule* _tmp9_;
	void* _tmp10_ = NULL;
	void* _tmp11_;
	GalaRegisterPluginFunction _register_ = NULL;
	void* _tmp12_;
	gpointer _register__target;
	GalaPluginInfo info = {0};
	GalaRegisterPluginFunction _tmp13_;
	gpointer _tmp13__target;
	GalaPluginInfo _tmp14_ = {0};
	GalaPluginInfo _tmp15_;
	GalaPluginInfo _tmp16_;
	const gchar* _tmp17_;
	GalaPluginInfo _tmp18_;
	gchar* _tmp19_;
	GModule* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GalaPluginInfo _tmp22_;
	gboolean result;
#line 88 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "PluginManager.vala"
	g_return_val_if_fail (plugin_name != NULL, FALSE);
#line 90 "PluginManager.vala"
	_tmp0_ = self->priv->plugin_dir;
#line 90 "PluginManager.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 90 "PluginManager.vala"
	_tmp2_ = _tmp1_;
#line 90 "PluginManager.vala"
	_tmp3_ = g_module_build_path (_tmp2_, plugin_name);
#line 90 "PluginManager.vala"
	_tmp4_ = _tmp3_;
#line 90 "PluginManager.vala"
	_g_free0 (_tmp2_);
#line 90 "PluginManager.vala"
	path = _tmp4_;
#line 91 "PluginManager.vala"
	_tmp5_ = path;
#line 91 "PluginManager.vala"
	_tmp6_ = g_module_open (_tmp5_, G_MODULE_BIND_LOCAL);
#line 91 "PluginManager.vala"
	module = _tmp6_;
#line 92 "PluginManager.vala"
	_tmp7_ = module;
#line 92 "PluginManager.vala"
	if (_tmp7_ == NULL) {
#line 608 "PluginManager.c"
		const gchar* _tmp8_;
#line 93 "PluginManager.vala"
		_tmp8_ = g_module_error ();
#line 93 "PluginManager.vala"
		g_warning ("PluginManager.vala:93: %s", _tmp8_);
#line 94 "PluginManager.vala"
		result = FALSE;
#line 94 "PluginManager.vala"
		_g_module_close0 (module);
#line 94 "PluginManager.vala"
		_g_free0 (path);
#line 94 "PluginManager.vala"
		return result;
#line 622 "PluginManager.c"
	}
#line 98 "PluginManager.vala"
	_tmp9_ = module;
#line 98 "PluginManager.vala"
	g_module_symbol (_tmp9_, "register_plugin", &_tmp10_);
#line 98 "PluginManager.vala"
	function = _tmp10_;
#line 99 "PluginManager.vala"
	_tmp11_ = function;
#line 99 "PluginManager.vala"
	if (_tmp11_ == NULL) {
#line 100 "PluginManager.vala"
		g_warning ("PluginManager.vala:100: %s failed to register: register_plugin() funct" \
"ion not found", plugin_name);
#line 101 "PluginManager.vala"
		result = FALSE;
#line 101 "PluginManager.vala"
		_g_module_close0 (module);
#line 101 "PluginManager.vala"
		_g_free0 (path);
#line 101 "PluginManager.vala"
		return result;
#line 644 "PluginManager.c"
	}
#line 103 "PluginManager.vala"
	_tmp12_ = function;
#line 103 "PluginManager.vala"
	_register_ = (GalaRegisterPluginFunction) _tmp12_;
#line 103 "PluginManager.vala"
	_register__target = NULL;
#line 105 "PluginManager.vala"
	_tmp13_ = _register_;
#line 105 "PluginManager.vala"
	_tmp13__target = _register__target;
#line 105 "PluginManager.vala"
	_tmp13_ (&_tmp14_, _tmp13__target);
#line 105 "PluginManager.vala"
	info = _tmp14_;
#line 106 "PluginManager.vala"
	_tmp15_ = info;
#line 106 "PluginManager.vala"
	if (g_type_is_a (_tmp15_.plugin_type, GALA_TYPE_PLUGIN) == FALSE) {
#line 107 "PluginManager.vala"
		g_warning ("PluginManager.vala:107: %s does not return a class of type Plugin", plugin_name);
#line 108 "PluginManager.vala"
		result = FALSE;
#line 108 "PluginManager.vala"
		gala_plugin_info_destroy (&info);
#line 108 "PluginManager.vala"
		_g_module_close0 (module);
#line 108 "PluginManager.vala"
		_g_free0 (path);
#line 108 "PluginManager.vala"
		return result;
#line 676 "PluginManager.c"
	}
#line 111 "PluginManager.vala"
	_tmp16_ = info;
#line 111 "PluginManager.vala"
	_tmp17_ = _tmp16_.name;
#line 111 "PluginManager.vala"
	_tmp18_ = info;
#line 111 "PluginManager.vala"
	if (!gala_plugin_manager_check_provides (self, _tmp17_, _tmp18_.provides)) {
#line 112 "PluginManager.vala"
		result = FALSE;
#line 112 "PluginManager.vala"
		gala_plugin_info_destroy (&info);
#line 112 "PluginManager.vala"
		_g_module_close0 (module);
#line 112 "PluginManager.vala"
		_g_free0 (path);
#line 112 "PluginManager.vala"
		return result;
#line 696 "PluginManager.c"
	}
#line 115 "PluginManager.vala"
	_tmp19_ = g_strdup (plugin_name);
#line 115 "PluginManager.vala"
	_g_free0 (info.module_name);
#line 115 "PluginManager.vala"
	info.module_name = _tmp19_;
#line 116 "PluginManager.vala"
	_tmp20_ = module;
#line 116 "PluginManager.vala"
	g_module_make_resident (_tmp20_);
#line 118 "PluginManager.vala"
	_tmp22_ = info;
#line 118 "PluginManager.vala"
	if (_tmp22_.load_priority == GALA_LOAD_PRIORITY_DEFERRED) {
#line 712 "PluginManager.c"
		gboolean _tmp23_;
#line 118 "PluginManager.vala"
		_tmp23_ = self->priv->_initialized;
#line 118 "PluginManager.vala"
		_tmp21_ = !_tmp23_;
#line 718 "PluginManager.c"
	} else {
#line 118 "PluginManager.vala"
		_tmp21_ = FALSE;
#line 722 "PluginManager.c"
	}
#line 118 "PluginManager.vala"
	if (_tmp21_) {
#line 726 "PluginManager.c"
		GeeLinkedList* _tmp24_;
		GalaPluginInfo _tmp25_;
#line 119 "PluginManager.vala"
		_tmp24_ = self->priv->load_later_plugins;
#line 119 "PluginManager.vala"
		_tmp25_ = info;
#line 119 "PluginManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, &_tmp25_);
#line 735 "PluginManager.c"
	} else {
		GalaPluginInfo _tmp26_;
#line 121 "PluginManager.vala"
		_tmp26_ = info;
#line 121 "PluginManager.vala"
		gala_plugin_manager_load_plugin_class (self, &_tmp26_);
#line 742 "PluginManager.c"
	}
#line 124 "PluginManager.vala"
	result = TRUE;
#line 124 "PluginManager.vala"
	gala_plugin_info_destroy (&info);
#line 124 "PluginManager.vala"
	_g_module_close0 (module);
#line 124 "PluginManager.vala"
	_g_free0 (path);
#line 124 "PluginManager.vala"
	return result;
#line 754 "PluginManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 130 "PluginManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 762 "PluginManager.c"
}

static void
gala_plugin_manager_load_plugin_class (GalaPluginManager* self,
                                       GalaPluginInfo* info)
{
	GalaPlugin* plugin = NULL;
	GalaPluginInfo _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GHashTable* _tmp3_;
	GalaPluginInfo _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GalaPlugin* _tmp7_;
	GalaPlugin* _tmp8_;
	GalaPluginInfo _tmp9_;
	const gchar* _tmp10_;
	GalaPluginInfo _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_;
#line 127 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 127 "PluginManager.vala"
	g_return_if_fail (info != NULL);
#line 129 "PluginManager.vala"
	_tmp0_ = *info;
#line 129 "PluginManager.vala"
	_tmp1_ = g_object_new (_tmp0_.plugin_type, NULL);
#line 129 "PluginManager.vala"
	_tmp2_ = G_IS_INITIALLY_UNOWNED (_tmp1_) ? g_object_ref_sink (_tmp1_) : _tmp1_;
#line 129 "PluginManager.vala"
	plugin = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GALA_TYPE_PLUGIN, GalaPlugin);
#line 130 "PluginManager.vala"
	_tmp3_ = self->priv->plugins;
#line 130 "PluginManager.vala"
	_tmp4_ = *info;
#line 130 "PluginManager.vala"
	_tmp5_ = _tmp4_.module_name;
#line 130 "PluginManager.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 130 "PluginManager.vala"
	_tmp7_ = plugin;
#line 130 "PluginManager.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 130 "PluginManager.vala"
	g_hash_table_insert (_tmp3_, _tmp6_, _tmp8_);
#line 132 "PluginManager.vala"
	_tmp9_ = *info;
#line 132 "PluginManager.vala"
	_tmp10_ = _tmp9_.name;
#line 132 "PluginManager.vala"
	_tmp11_ = *info;
#line 132 "PluginManager.vala"
	_tmp12_ = _tmp11_.module_name;
#line 132 "PluginManager.vala"
	g_debug ("PluginManager.vala:132: Loaded plugin %s (%s)", _tmp10_, _tmp12_);
#line 134 "PluginManager.vala"
	_tmp13_ = self->priv->_initialized;
#line 134 "PluginManager.vala"
	if (_tmp13_) {
#line 824 "PluginManager.c"
		GalaPluginInfo _tmp14_;
		const gchar* _tmp15_;
		GalaPlugin* _tmp16_;
#line 135 "PluginManager.vala"
		_tmp14_ = *info;
#line 135 "PluginManager.vala"
		_tmp15_ = _tmp14_.module_name;
#line 135 "PluginManager.vala"
		_tmp16_ = plugin;
#line 135 "PluginManager.vala"
		gala_plugin_manager_initialize_plugin (self, _tmp15_, _tmp16_);
#line 136 "PluginManager.vala"
		gala_plugin_manager_recalculate_regions (self);
#line 838 "PluginManager.c"
	}
#line 129 "PluginManager.vala"
	_g_object_unref0 (plugin);
#line 842 "PluginManager.c"
}

static void
_gala_plugin_manager_recalculate_regions_gala_plugin_region_changed (GalaPlugin* _sender,
                                                                     gpointer self)
{
#line 143 "PluginManager.vala"
	gala_plugin_manager_recalculate_regions ((GalaPluginManager*) self);
#line 851 "PluginManager.c"
}

static void
gala_plugin_manager_initialize_plugin (GalaPluginManager* self,
                                       const gchar* plugin_name,
                                       GalaPlugin* plugin)
{
	GalaWindowManager* _tmp0_;
#line 140 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 140 "PluginManager.vala"
	g_return_if_fail (plugin_name != NULL);
#line 140 "PluginManager.vala"
	g_return_if_fail (plugin != NULL);
#line 142 "PluginManager.vala"
	_tmp0_ = self->priv->wm;
#line 142 "PluginManager.vala"
	gala_plugin_initialize (plugin, _tmp0_);
#line 143 "PluginManager.vala"
	g_signal_connect_object (plugin, "region-changed", (GCallback) _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed, self, 0);
#line 872 "PluginManager.c"
}

static gboolean
gala_plugin_manager_check_provides (GalaPluginManager* self,
                                    const gchar* name,
                                    GalaPluginFunction provides)
{
	gchar* message = NULL;
	gchar* _tmp0_;
	gboolean result;
#line 146 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 146 "PluginManager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 148 "PluginManager.vala"
	_tmp0_ = g_strdup ("Plugins %s and %s both provide %s functionality, using first one only");
#line 148 "PluginManager.vala"
	message = _tmp0_;
#line 149 "PluginManager.vala"
	switch (provides) {
#line 149 "PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WORKSPACE_VIEW:
#line 895 "PluginManager.c"
		{
			const gchar* _tmp1_;
#line 151 "PluginManager.vala"
			_tmp1_ = self->priv->_workspace_view_provider;
#line 151 "PluginManager.vala"
			if (_tmp1_ != NULL) {
#line 902 "PluginManager.c"
				const gchar* _tmp2_;
				const gchar* _tmp3_;
#line 152 "PluginManager.vala"
				_tmp2_ = message;
#line 152 "PluginManager.vala"
				_tmp3_ = self->priv->_workspace_view_provider;
#line 152 "PluginManager.vala"
				g_warning (_tmp2_, _tmp3_, name, "workspace view");
#line 153 "PluginManager.vala"
				result = FALSE;
#line 153 "PluginManager.vala"
				_g_free0 (message);
#line 153 "PluginManager.vala"
				return result;
#line 917 "PluginManager.c"
			}
#line 155 "PluginManager.vala"
			gala_plugin_manager_set_workspace_view_provider (self, name);
#line 156 "PluginManager.vala"
			result = TRUE;
#line 156 "PluginManager.vala"
			_g_free0 (message);
#line 156 "PluginManager.vala"
			return result;
#line 927 "PluginManager.c"
		}
#line 149 "PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WINDOW_OVERVIEW:
#line 931 "PluginManager.c"
		{
			const gchar* _tmp4_;
#line 158 "PluginManager.vala"
			_tmp4_ = self->priv->_window_overview_provider;
#line 158 "PluginManager.vala"
			if (_tmp4_ != NULL) {
#line 938 "PluginManager.c"
				const gchar* _tmp5_;
				const gchar* _tmp6_;
#line 159 "PluginManager.vala"
				_tmp5_ = message;
#line 159 "PluginManager.vala"
				_tmp6_ = self->priv->_window_overview_provider;
#line 159 "PluginManager.vala"
				g_warning (_tmp5_, _tmp6_, name, "window overview");
#line 160 "PluginManager.vala"
				result = FALSE;
#line 160 "PluginManager.vala"
				_g_free0 (message);
#line 160 "PluginManager.vala"
				return result;
#line 953 "PluginManager.c"
			}
#line 162 "PluginManager.vala"
			gala_plugin_manager_set_window_overview_provider (self, name);
#line 163 "PluginManager.vala"
			result = TRUE;
#line 163 "PluginManager.vala"
			_g_free0 (message);
#line 163 "PluginManager.vala"
			return result;
#line 963 "PluginManager.c"
		}
#line 149 "PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_DESKTOP:
#line 967 "PluginManager.c"
		{
			const gchar* _tmp7_;
#line 165 "PluginManager.vala"
			_tmp7_ = self->priv->_desktop_provider;
#line 165 "PluginManager.vala"
			if (_tmp7_ != NULL) {
#line 974 "PluginManager.c"
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 166 "PluginManager.vala"
				_tmp8_ = message;
#line 166 "PluginManager.vala"
				_tmp9_ = self->priv->_desktop_provider;
#line 166 "PluginManager.vala"
				g_warning (_tmp8_, _tmp9_, name, "desktop");
#line 167 "PluginManager.vala"
				result = FALSE;
#line 167 "PluginManager.vala"
				_g_free0 (message);
#line 167 "PluginManager.vala"
				return result;
#line 989 "PluginManager.c"
			}
#line 169 "PluginManager.vala"
			gala_plugin_manager_set_desktop_provider (self, name);
#line 170 "PluginManager.vala"
			result = TRUE;
#line 170 "PluginManager.vala"
			_g_free0 (message);
#line 170 "PluginManager.vala"
			return result;
#line 999 "PluginManager.c"
		}
#line 149 "PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WINDOW_SWITCHER:
#line 1003 "PluginManager.c"
		{
			const gchar* _tmp10_;
#line 172 "PluginManager.vala"
			_tmp10_ = self->priv->_window_switcher_provider;
#line 172 "PluginManager.vala"
			if (_tmp10_ != NULL) {
#line 1010 "PluginManager.c"
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 173 "PluginManager.vala"
				_tmp11_ = message;
#line 173 "PluginManager.vala"
				_tmp12_ = self->priv->_window_switcher_provider;
#line 173 "PluginManager.vala"
				g_warning (_tmp11_, _tmp12_, name, "window switcher");
#line 174 "PluginManager.vala"
				result = FALSE;
#line 174 "PluginManager.vala"
				_g_free0 (message);
#line 174 "PluginManager.vala"
				return result;
#line 1025 "PluginManager.c"
			}
#line 176 "PluginManager.vala"
			gala_plugin_manager_set_window_switcher_provider (self, name);
#line 177 "PluginManager.vala"
			result = TRUE;
#line 177 "PluginManager.vala"
			_g_free0 (message);
#line 177 "PluginManager.vala"
			return result;
#line 1035 "PluginManager.c"
		}
		default:
#line 149 "PluginManager.vala"
		break;
#line 1040 "PluginManager.c"
	}
#line 180 "PluginManager.vala"
	result = TRUE;
#line 180 "PluginManager.vala"
	_g_free0 (message);
#line 180 "PluginManager.vala"
	return result;
#line 1048 "PluginManager.c"
}

static void
_gala_plugin_manager_initialize_plugin_gh_func (gconstpointer key,
                                                gconstpointer value,
                                                gpointer self)
{
#line 187 "PluginManager.vala"
	gala_plugin_manager_initialize_plugin ((GalaPluginManager*) self, (const gchar*) key, (GalaPlugin*) value);
#line 1058 "PluginManager.c"
}

void
gala_plugin_manager_initialize (GalaPluginManager* self,
                                GalaWindowManager* _wm)
{
	GalaWindowManager* _tmp0_;
	GHashTable* _tmp1_;
#line 183 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 183 "PluginManager.vala"
	g_return_if_fail (_wm != NULL);
#line 185 "PluginManager.vala"
	_tmp0_ = _g_object_ref0 (_wm);
#line 185 "PluginManager.vala"
	_g_object_unref0 (self->priv->wm);
#line 185 "PluginManager.vala"
	self->priv->wm = _tmp0_;
#line 187 "PluginManager.vala"
	_tmp1_ = self->priv->plugins;
#line 187 "PluginManager.vala"
	g_hash_table_foreach (_tmp1_, _gala_plugin_manager_initialize_plugin_gh_func, self);
#line 188 "PluginManager.vala"
	gala_plugin_manager_recalculate_regions (self);
#line 190 "PluginManager.vala"
	gala_plugin_manager_set_initialized (self, TRUE);
#line 1085 "PluginManager.c"
}

void
gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self)
{
	GeeLinkedList* _tmp10_;
#line 193 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 1094 "PluginManager.c"
	{
		GeeLinkedList* _info_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _info_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _info_index = 0;
#line 195 "PluginManager.vala"
		_tmp0_ = self->priv->load_later_plugins;
#line 195 "PluginManager.vala"
		_info_list = _tmp0_;
#line 195 "PluginManager.vala"
		_tmp1_ = _info_list;
#line 195 "PluginManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 195 "PluginManager.vala"
		_tmp3_ = _tmp2_;
#line 195 "PluginManager.vala"
		_info_size = _tmp3_;
#line 195 "PluginManager.vala"
		_info_index = -1;
#line 195 "PluginManager.vala"
		while (TRUE) {
#line 1119 "PluginManager.c"
			gint _tmp4_;
			gint _tmp5_;
			GalaPluginInfo* info = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			GalaPluginInfo* _tmp8_;
			GalaPluginInfo _tmp9_;
#line 195 "PluginManager.vala"
			_info_index = _info_index + 1;
#line 195 "PluginManager.vala"
			_tmp4_ = _info_index;
#line 195 "PluginManager.vala"
			_tmp5_ = _info_size;
#line 195 "PluginManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 195 "PluginManager.vala"
				break;
#line 1137 "PluginManager.c"
			}
#line 195 "PluginManager.vala"
			_tmp6_ = _info_list;
#line 195 "PluginManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _info_index);
#line 195 "PluginManager.vala"
			info = (GalaPluginInfo*) _tmp7_;
#line 196 "PluginManager.vala"
			_tmp8_ = info;
#line 196 "PluginManager.vala"
			_tmp9_ = *_tmp8_;
#line 196 "PluginManager.vala"
			gala_plugin_manager_load_plugin_class (self, &_tmp9_);
#line 195 "PluginManager.vala"
			__vala_GalaPluginInfo_free0 (info);
#line 1153 "PluginManager.c"
		}
	}
#line 199 "PluginManager.vala"
	_tmp10_ = self->priv->load_later_plugins;
#line 199 "PluginManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp10_);
#line 1160 "PluginManager.c"
}

GalaPlugin*
gala_plugin_manager_get_plugin (GalaPluginManager* self,
                                const gchar* id)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GalaPlugin* _tmp2_;
	GalaPlugin* result;
#line 202 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "PluginManager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 204 "PluginManager.vala"
	_tmp0_ = self->priv->plugins;
#line 204 "PluginManager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, id);
#line 204 "PluginManager.vala"
	_tmp2_ = _g_object_ref0 ((GalaPlugin*) _tmp1_);
#line 204 "PluginManager.vala"
	result = _tmp2_;
#line 204 "PluginManager.vala"
	return result;
#line 1185 "PluginManager.c"
}

/**
 * Iterate over all plugins and grab their regions, update the regions
 * array accordingly and emit the regions_changed signal.
 */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 211 "PluginManager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 211 "PluginManager.vala"
	return _data4_;
#line 1199 "PluginManager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 211 "PluginManager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1209 "PluginManager.c"
		GalaPluginManager* self;
#line 211 "PluginManager.vala"
		self = _data4_->self;
#line 211 "PluginManager.vala"
		_data4_->regions = (g_free (_data4_->regions), NULL);
#line 211 "PluginManager.vala"
		_g_object_unref0 (self);
#line 211 "PluginManager.vala"
		g_slice_free (Block4Data, _data4_);
#line 1219 "PluginManager.c"
	}
}

static void
_vala_array_add4 (XRectangle* * array,
                  gint* length,
                  gint* size,
                  XRectangle value)
{
#line 224 "PluginManager.vala"
	if ((*length) == (*size)) {
#line 224 "PluginManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 224 "PluginManager.vala"
		*array = g_renew (XRectangle, *array, *size);
#line 1235 "PluginManager.c"
	}
#line 224 "PluginManager.vala"
	(*array)[(*length)++] = value;
#line 1239 "PluginManager.c"
}

static void
__lambda40_ (Block4Data* _data4_,
             const gchar* name,
             GalaPlugin* plugin)
{
	GalaPluginManager* self;
	MetaRectangle* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	MetaRectangle* _tmp2_;
	gint _tmp2__length1;
#line 215 "PluginManager.vala"
	self = _data4_->self;
#line 215 "PluginManager.vala"
	g_return_if_fail (name != NULL);
#line 215 "PluginManager.vala"
	g_return_if_fail (plugin != NULL);
#line 216 "PluginManager.vala"
	_tmp0_ = gala_plugin_get_region (plugin, &_tmp1_);
#line 216 "PluginManager.vala"
	_tmp0__length1 = _tmp1_;
#line 216 "PluginManager.vala"
	_tmp2_ = _tmp0_;
#line 216 "PluginManager.vala"
	_tmp2__length1 = _tmp0__length1;
#line 1267 "PluginManager.c"
	{
		MetaRectangle* region_collection = NULL;
		gint region_collection_length1 = 0;
		gint _region_collection_size_ = 0;
		gint region_it = 0;
#line 216 "PluginManager.vala"
		region_collection = _tmp2_;
#line 216 "PluginManager.vala"
		region_collection_length1 = _tmp2__length1;
#line 216 "PluginManager.vala"
		for (region_it = 0; region_it < region_collection_length1; region_it = region_it + 1) {
#line 1279 "PluginManager.c"
			MetaRectangle region = {0};
#line 216 "PluginManager.vala"
			region = region_collection[region_it];
#line 1283 "PluginManager.c"
			{
				XRectangle rect = {0};
				MetaRectangle _tmp3_;
				MetaRectangle _tmp4_;
				MetaRectangle _tmp5_;
				MetaRectangle _tmp6_;
				XRectangle _tmp7_ = {0};
#line 217 "PluginManager.vala"
				_tmp3_ = region;
#line 217 "PluginManager.vala"
				_tmp4_ = region;
#line 217 "PluginManager.vala"
				_tmp5_ = region;
#line 217 "PluginManager.vala"
				_tmp6_ = region;
#line 217 "PluginManager.vala"
				_tmp7_.x = (gshort) _tmp3_.x;
#line 217 "PluginManager.vala"
				_tmp7_.y = (gshort) _tmp4_.y;
#line 217 "PluginManager.vala"
				_tmp7_.width = (gushort) _tmp5_.width;
#line 217 "PluginManager.vala"
				_tmp7_.height = (gushort) _tmp6_.height;
#line 217 "PluginManager.vala"
				rect = _tmp7_;
#line 224 "PluginManager.vala"
				_vala_array_add4 (&_data4_->regions, &_data4_->regions_length1, &_data4_->_regions_size_, rect);
#line 1311 "PluginManager.c"
			}
		}
	}
}

static void
___lambda40__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 215 "PluginManager.vala"
	__lambda40_ (self, (const gchar*) key, (GalaPlugin*) value);
#line 1324 "PluginManager.c"
}

static void
gala_plugin_manager_recalculate_regions (GalaPluginManager* self)
{
	Block4Data* _data4_;
	XRectangle* _tmp0_;
	GHashTable* _tmp1_;
#line 211 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 211 "PluginManager.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 211 "PluginManager.vala"
	_data4_->_ref_count_ = 1;
#line 211 "PluginManager.vala"
	_data4_->self = g_object_ref (self);
#line 213 "PluginManager.vala"
	_tmp0_ = g_new0 (XRectangle, 0);
#line 213 "PluginManager.vala"
	_data4_->regions = _tmp0_;
#line 213 "PluginManager.vala"
	_data4_->regions_length1 = 0;
#line 213 "PluginManager.vala"
	_data4_->_regions_size_ = _data4_->regions_length1;
#line 215 "PluginManager.vala"
	_tmp1_ = self->priv->plugins;
#line 215 "PluginManager.vala"
	g_hash_table_foreach (_tmp1_, ___lambda40__gh_func, _data4_);
#line 228 "PluginManager.vala"
	gala_plugin_manager_set_regions (self, _data4_->regions, _data4_->regions_length1);
#line 229 "PluginManager.vala"
	g_signal_emit (self, gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL], 0);
#line 211 "PluginManager.vala"
	block4_data_unref (_data4_);
#line 211 "PluginManager.vala"
	_data4_ = NULL;
#line 1361 "PluginManager.c"
}

gboolean
gala_plugin_manager_get_initialized (GalaPluginManager* self)
{
	gboolean result;
#line 35 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "PluginManager.vala"
	result = self->priv->_initialized;
#line 35 "PluginManager.vala"
	return result;
#line 1374 "PluginManager.c"
}

static void
gala_plugin_manager_set_initialized (GalaPluginManager* self,
                                     gboolean value)
{
	gboolean old_value;
#line 35 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 35 "PluginManager.vala"
	old_value = gala_plugin_manager_get_initialized (self);
#line 35 "PluginManager.vala"
	if (old_value != value) {
#line 35 "PluginManager.vala"
		self->priv->_initialized = value;
#line 35 "PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY]);
#line 1392 "PluginManager.c"
	}
}

XRectangle*
gala_plugin_manager_get_regions (GalaPluginManager* self,
                                 gint* result_length1)
{
	XRectangle* result;
	XRectangle* _tmp0_;
	gint _tmp0__length1;
	XRectangle* _tmp1_;
	gint _tmp1__length1;
#line 37 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "PluginManager.vala"
	_tmp0_ = self->priv->_regions;
#line 37 "PluginManager.vala"
	_tmp0__length1 = self->priv->_regions_length1;
#line 37 "PluginManager.vala"
	_tmp1_ = _tmp0_;
#line 37 "PluginManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 37 "PluginManager.vala"
	if (result_length1) {
#line 37 "PluginManager.vala"
		*result_length1 = _tmp1__length1;
#line 1419 "PluginManager.c"
	}
#line 37 "PluginManager.vala"
	result = _tmp1_;
#line 37 "PluginManager.vala"
	return result;
#line 1425 "PluginManager.c"
}

static XRectangle*
_vala_array_dup2 (XRectangle* self,
                  gssize length)
{
#line 37 "PluginManager.vala"
	if (length > 0) {
#line 37 "PluginManager.vala"
		return _vala_memdup2 (self, length * sizeof (XRectangle));
#line 1436 "PluginManager.c"
	}
#line 37 "PluginManager.vala"
	return NULL;
#line 1440 "PluginManager.c"
}

static void
gala_plugin_manager_set_regions (GalaPluginManager* self,
                                 XRectangle* value,
                                 gint value_length1)
{
	XRectangle* _tmp0_;
	gint _tmp0__length1;
#line 37 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "PluginManager.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup2 (value, value_length1) : value;
#line 37 "PluginManager.vala"
	_tmp0__length1 = value_length1;
#line 37 "PluginManager.vala"
	self->priv->_regions = (g_free (self->priv->_regions), NULL);
#line 37 "PluginManager.vala"
	self->priv->_regions = _tmp0_;
#line 37 "PluginManager.vala"
	self->priv->_regions_length1 = _tmp0__length1;
#line 37 "PluginManager.vala"
	self->priv->__regions_size_ = self->priv->_regions_length1;
#line 1464 "PluginManager.c"
}

const gchar*
gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "PluginManager.vala"
	_tmp0_ = self->priv->_window_switcher_provider;
#line 39 "PluginManager.vala"
	result = _tmp0_;
#line 39 "PluginManager.vala"
	return result;
#line 1480 "PluginManager.c"
}

static void
gala_plugin_manager_set_window_switcher_provider (GalaPluginManager* self,
                                                  const gchar* value)
{
	gchar* old_value;
#line 39 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "PluginManager.vala"
	old_value = gala_plugin_manager_get_window_switcher_provider (self);
#line 39 "PluginManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1494 "PluginManager.c"
		gchar* _tmp0_;
#line 39 "PluginManager.vala"
		_tmp0_ = g_strdup (value);
#line 39 "PluginManager.vala"
		_g_free0 (self->priv->_window_switcher_provider);
#line 39 "PluginManager.vala"
		self->priv->_window_switcher_provider = _tmp0_;
#line 39 "PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY]);
#line 1504 "PluginManager.c"
	}
}

const gchar*
gala_plugin_manager_get_desktop_provider (GalaPluginManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "PluginManager.vala"
	_tmp0_ = self->priv->_desktop_provider;
#line 40 "PluginManager.vala"
	result = _tmp0_;
#line 40 "PluginManager.vala"
	return result;
#line 1521 "PluginManager.c"
}

static void
gala_plugin_manager_set_desktop_provider (GalaPluginManager* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 40 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 40 "PluginManager.vala"
	old_value = gala_plugin_manager_get_desktop_provider (self);
#line 40 "PluginManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1535 "PluginManager.c"
		gchar* _tmp0_;
#line 40 "PluginManager.vala"
		_tmp0_ = g_strdup (value);
#line 40 "PluginManager.vala"
		_g_free0 (self->priv->_desktop_provider);
#line 40 "PluginManager.vala"
		self->priv->_desktop_provider = _tmp0_;
#line 40 "PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER_PROPERTY]);
#line 1545 "PluginManager.c"
	}
}

const gchar*
gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "PluginManager.vala"
	_tmp0_ = self->priv->_window_overview_provider;
#line 41 "PluginManager.vala"
	result = _tmp0_;
#line 41 "PluginManager.vala"
	return result;
#line 1562 "PluginManager.c"
}

static void
gala_plugin_manager_set_window_overview_provider (GalaPluginManager* self,
                                                  const gchar* value)
{
	gchar* old_value;
#line 41 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 41 "PluginManager.vala"
	old_value = gala_plugin_manager_get_window_overview_provider (self);
#line 41 "PluginManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1576 "PluginManager.c"
		gchar* _tmp0_;
#line 41 "PluginManager.vala"
		_tmp0_ = g_strdup (value);
#line 41 "PluginManager.vala"
		_g_free0 (self->priv->_window_overview_provider);
#line 41 "PluginManager.vala"
		self->priv->_window_overview_provider = _tmp0_;
#line 41 "PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY]);
#line 1586 "PluginManager.c"
	}
}

const gchar*
gala_plugin_manager_get_workspace_view_provider (GalaPluginManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "PluginManager.vala"
	_tmp0_ = self->priv->_workspace_view_provider;
#line 42 "PluginManager.vala"
	result = _tmp0_;
#line 42 "PluginManager.vala"
	return result;
#line 1603 "PluginManager.c"
}

static void
gala_plugin_manager_set_workspace_view_provider (GalaPluginManager* self,
                                                 const gchar* value)
{
	gchar* old_value;
#line 42 "PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 42 "PluginManager.vala"
	old_value = gala_plugin_manager_get_workspace_view_provider (self);
#line 42 "PluginManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1617 "PluginManager.c"
		gchar* _tmp0_;
#line 42 "PluginManager.vala"
		_tmp0_ = g_strdup (value);
#line 42 "PluginManager.vala"
		_g_free0 (self->priv->_workspace_view_provider);
#line 42 "PluginManager.vala"
		self->priv->_workspace_view_provider = _tmp0_;
#line 42 "PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER_PROPERTY]);
#line 1627 "PluginManager.c"
	}
}

static void
gala_plugin_manager_class_init (GalaPluginManagerClass * klass,
                                gpointer klass_data)
{
#line 22 "PluginManager.vala"
	gala_plugin_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "PluginManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaPluginManager_private_offset);
#line 22 "PluginManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugin_manager_get_property;
#line 22 "PluginManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugin_manager_set_property;
#line 22 "PluginManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugin_manager_finalize;
#line 22 "PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY] = g_param_spec_boolean ("initialized", "initialized", "initialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY] = g_param_spec_string ("window-switcher-provider", "window-switcher-provider", "window-switcher-provider", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER_PROPERTY] = g_param_spec_string ("desktop-provider", "desktop-provider", "desktop-provider", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY] = g_param_spec_string ("window-overview-provider", "window-overview-provider", "window-overview-provider", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER_PROPERTY, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER_PROPERTY] = g_param_spec_string ("workspace-view-provider", "workspace-view-provider", "workspace-view-provider", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "PluginManager.vala"
	gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL] = g_signal_new ("regions-changed", GALA_TYPE_PLUGIN_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1657 "PluginManager.c"
}

static void
gala_plugin_manager_instance_init (GalaPluginManager * self,
                                   gpointer klass)
{
#line 22 "PluginManager.vala"
	self->priv = gala_plugin_manager_get_instance_private (self);
#line 35 "PluginManager.vala"
	self->priv->_initialized = FALSE;
#line 39 "PluginManager.vala"
	self->priv->_window_switcher_provider = NULL;
#line 40 "PluginManager.vala"
	self->priv->_desktop_provider = NULL;
#line 41 "PluginManager.vala"
	self->priv->_window_overview_provider = NULL;
#line 42 "PluginManager.vala"
	self->priv->_workspace_view_provider = NULL;
#line 47 "PluginManager.vala"
	self->priv->wm = NULL;
#line 1678 "PluginManager.c"
}

static void
gala_plugin_manager_finalize (GObject * obj)
{
	GalaPluginManager * self;
#line 22 "PluginManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 37 "PluginManager.vala"
	self->priv->_regions = (g_free (self->priv->_regions), NULL);
#line 39 "PluginManager.vala"
	_g_free0 (self->priv->_window_switcher_provider);
#line 40 "PluginManager.vala"
	_g_free0 (self->priv->_desktop_provider);
#line 41 "PluginManager.vala"
	_g_free0 (self->priv->_window_overview_provider);
#line 42 "PluginManager.vala"
	_g_free0 (self->priv->_workspace_view_provider);
#line 44 "PluginManager.vala"
	_g_hash_table_unref0 (self->priv->plugins);
#line 45 "PluginManager.vala"
	_g_object_unref0 (self->priv->plugin_dir);
#line 47 "PluginManager.vala"
	_g_object_unref0 (self->priv->wm);
#line 49 "PluginManager.vala"
	_g_object_unref0 (self->priv->load_later_plugins);
#line 127 "PluginManager.vala"
	G_OBJECT_CLASS (gala_plugin_manager_parent_class)->finalize (obj);
#line 1707 "PluginManager.c"
}

static GType
gala_plugin_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugin_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginManager), 0, (GInstanceInitFunc) gala_plugin_manager_instance_init, NULL };
	GType gala_plugin_manager_type_id;
	gala_plugin_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaPluginManager", &g_define_type_info, 0);
	GalaPluginManager_private_offset = g_type_add_instance_private (gala_plugin_manager_type_id, sizeof (GalaPluginManagerPrivate));
	return gala_plugin_manager_type_id;
}

GType
gala_plugin_manager_get_type (void)
{
	static volatile gsize gala_plugin_manager_type_id__once = 0;
	if (g_once_init_enter (&gala_plugin_manager_type_id__once)) {
		GType gala_plugin_manager_type_id;
		gala_plugin_manager_type_id = gala_plugin_manager_get_type_once ();
		g_once_init_leave (&gala_plugin_manager_type_id__once, gala_plugin_manager_type_id);
	}
	return gala_plugin_manager_type_id__once;
}

static void
_vala_gala_plugin_manager_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GalaPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 22 "PluginManager.vala"
	switch (property_id) {
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY:
#line 22 "PluginManager.vala"
		g_value_set_boolean (value, gala_plugin_manager_get_initialized (self));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_window_switcher_provider (self));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_desktop_provider (self));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_window_overview_provider (self));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_workspace_view_provider (self));
#line 22 "PluginManager.vala"
		break;
#line 1772 "PluginManager.c"
		default:
#line 22 "PluginManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "PluginManager.vala"
		break;
#line 1778 "PluginManager.c"
	}
}

static void
_vala_gala_plugin_manager_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GalaPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 22 "PluginManager.vala"
	switch (property_id) {
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_INITIALIZED_PROPERTY:
#line 22 "PluginManager.vala"
		gala_plugin_manager_set_initialized (self, g_value_get_boolean (value));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		gala_plugin_manager_set_window_switcher_provider (self, g_value_get_string (value));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		gala_plugin_manager_set_desktop_provider (self, g_value_get_string (value));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		gala_plugin_manager_set_window_overview_provider (self, g_value_get_string (value));
#line 22 "PluginManager.vala"
		break;
#line 22 "PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER_PROPERTY:
#line 22 "PluginManager.vala"
		gala_plugin_manager_set_workspace_view_provider (self, g_value_get_string (value));
#line 22 "PluginManager.vala"
		break;
#line 1822 "PluginManager.c"
		default:
#line 22 "PluginManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "PluginManager.vala"
		break;
#line 1828 "PluginManager.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 22 "PluginManager.vala"
	if (mem && byte_size != 0) {
#line 22 "PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 22 "PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1843 "PluginManager.c"
	} else {
#line 22 "PluginManager.vala"
		new_mem = NULL;
#line 1847 "PluginManager.c"
	}
#line 22 "PluginManager.vala"
	return new_mem;
#line 1851 "PluginManager.c"
}

