/* WorkspaceManager.c generated by valac 0.56.3, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2015 Deepin Technology Co., Ltd.*/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <glib.h>
#include <meta/screen.h>
#include <meta/meta-plugin.h>
#include <meta/prefs.h>
#include <meta/common.h>
#include <meta/window.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <meta/display.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GALA_TYPE_BEHAVIOR_SETTINGS (gala_behavior_settings_get_type ())
#define GALA_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettings))
#define GALA_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))
#define GALA_IS_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_IS_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_BEHAVIOR_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))

typedef struct _GalaBehaviorSettings GalaBehaviorSettings;
typedef struct _GalaBehaviorSettingsClass GalaBehaviorSettingsClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};

static gint GalaWorkspaceManager_private_offset;
static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

VALA_EXTERN GType gala_workspace_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWorkspaceManager, g_object_unref)
VALA_EXTERN GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                            MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                     gpointer self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                             MetaScreen* screen,
                                             gint index);
static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                          gint object,
                                                                          gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                                MetaScreen* screen,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                                gint object,
                                                                                gint p0,
                                                                                MetaMotionDirection p1,
                                                                                gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint index);
static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                              gint object,
                                                                              gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                                    MetaScreen* screen,
                                                    gint monitor,
                                                    MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                        gint object,
                                                                                        MetaWindow* p0,
                                                                                        gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                                 MetaScreen* screen,
                                                 gint monitor,
                                                 MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                                  gint object,
                                                                                  MetaWindow* p0,
                                                                                  gpointer self);
VALA_EXTERN void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type,
                                                        GalaWindowManager* wm);
VALA_EXTERN GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                          MetaWorkspace* workspace,
                                          MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                       MetaWindow* object,
                                                                       gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                            MetaWorkspace* workspace,
                                            MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                           MetaWindow* object,
                                                                           gpointer self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                              MetaWorkspace* workspace);
VALA_EXTERN GType gala_behavior_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBehaviorSettings, g_object_unref)
VALA_EXTERN GalaBehaviorSettings* gala_behavior_settings_get_default (void);
VALA_EXTERN gchar** gala_behavior_settings_get_auto_focus_windows (GalaBehaviorSettings* self,
                                                       gint* result_length1);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
VALA_EXTERN gboolean gala_internal_utils_workspaces_only_on_primary (void);
VALA_EXTERN void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
VALA_EXTERN void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
VALA_EXTERN void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                                    GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static GType gala_workspace_manager_get_type_once (void);
static void _vala_gala_workspace_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_workspace_manager_get_instance_private (GalaWorkspaceManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWorkspaceManager_private_offset);
}

static void
_gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref,
                                                                gpointer self)
{
#line 79 "WorkspaceManager.vala"
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
#line 205 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender,
                                                                     gint object,
                                                                     gpointer self)
{
#line 81 "WorkspaceManager.vala"
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
#line 215 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender,
                                                                           gint object,
                                                                           gint p0,
                                                                           MetaMotionDirection p1,
                                                                           gpointer self)
{
#line 82 "WorkspaceManager.vala"
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
#line 227 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender,
                                                                         gint object,
                                                                         gpointer self)
{
#line 83 "WorkspaceManager.vala"
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 237 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender,
                                                                                   gint object,
                                                                                   MetaWindow* p0,
                                                                                   gpointer self)
{
#line 84 "WorkspaceManager.vala"
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 248 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender,
                                                                             gint object,
                                                                             MetaWindow* p0,
                                                                             gpointer self)
{
#line 85 "WorkspaceManager.vala"
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 259 "WorkspaceManager.c"
}

void
gala_workspace_manager_init (GalaWindowManager* wm)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 25 "WorkspaceManager.vala"
	g_return_if_fail (wm != NULL);
#line 25 "WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 25 "WorkspaceManager.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
#line 28 "WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_new (wm);
#line 28 "WorkspaceManager.vala"
	_g_object_unref0 (gala_workspace_manager_instance);
#line 28 "WorkspaceManager.vala"
	gala_workspace_manager_instance = _tmp1_;
#line 279 "WorkspaceManager.c"
}

GalaWorkspaceManager*
gala_workspace_manager_get_default (void)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
	GalaWorkspaceManager* result;
#line 31 "WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 31 "WorkspaceManager.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 34 "WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_instance;
#line 34 "WorkspaceManager.vala"
	result = _tmp1_;
#line 34 "WorkspaceManager.vala"
	return result;
#line 298 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaWorkspaceManager * self = NULL;
#line 44 "WorkspaceManager.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 46 "WorkspaceManager.vala"
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", wm, NULL);
#line 44 "WorkspaceManager.vala"
	return self;
#line 312 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_new (GalaWindowManager* wm)
{
#line 44 "WorkspaceManager.vala"
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
#line 320 "WorkspaceManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 90 "WorkspaceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 328 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                  MetaWindow* object,
                                                                  gpointer self)
{
#line 94 "WorkspaceManager.vala"
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
#line 338 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                      MetaWindow* object,
                                                                      gpointer self)
{
#line 95 "WorkspaceManager.vala"
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 348 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                        MetaScreen* screen,
                                        gint index)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
#line 88 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 88 "WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 90 "WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspace_by_index (screen, index);
#line 90 "WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 90 "WorkspaceManager.vala"
	workspace = _tmp1_;
#line 91 "WorkspaceManager.vala"
	_tmp2_ = workspace;
#line 91 "WorkspaceManager.vala"
	if (_tmp2_ == NULL) {
#line 92 "WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 92 "WorkspaceManager.vala"
		return;
#line 380 "WorkspaceManager.c"
	}
#line 94 "WorkspaceManager.vala"
	_tmp3_ = workspace;
#line 94 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp3_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
#line 95 "WorkspaceManager.vala"
	_tmp4_ = workspace;
#line 95 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp4_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
#line 88 "WorkspaceManager.vala"
	_g_object_unref0 (workspace);
#line 392 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self,
                                          MetaScreen* screen,
                                          gint index)
{
	GList* existing_workspaces = NULL;
	GList* _tmp0_;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp1_;
	GeeIterator* _tmp2_;
#line 98 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 98 "WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 100 "WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspaces (screen);
#line 100 "WorkspaceManager.vala"
	existing_workspaces = _tmp0_;
#line 102 "WorkspaceManager.vala"
	_tmp1_ = self->priv->workspaces_marked_removed;
#line 102 "WorkspaceManager.vala"
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 102 "WorkspaceManager.vala"
	it = _tmp2_;
#line 103 "WorkspaceManager.vala"
	while (TRUE) {
#line 421 "WorkspaceManager.c"
		GeeIterator* _tmp3_;
		GList* _tmp4_;
		GeeIterator* _tmp5_;
		gpointer _tmp6_;
		MetaWorkspace* _tmp7_;
		gboolean _tmp8_;
#line 103 "WorkspaceManager.vala"
		_tmp3_ = it;
#line 103 "WorkspaceManager.vala"
		if (!gee_iterator_next (_tmp3_)) {
#line 103 "WorkspaceManager.vala"
			break;
#line 434 "WorkspaceManager.c"
		}
#line 104 "WorkspaceManager.vala"
		_tmp4_ = existing_workspaces;
#line 104 "WorkspaceManager.vala"
		_tmp5_ = it;
#line 104 "WorkspaceManager.vala"
		_tmp6_ = gee_iterator_get (_tmp5_);
#line 104 "WorkspaceManager.vala"
		_tmp7_ = (MetaWorkspace*) _tmp6_;
#line 104 "WorkspaceManager.vala"
		_tmp8_ = g_list_index (_tmp4_, _tmp7_) < 0;
#line 104 "WorkspaceManager.vala"
		_g_object_unref0 (_tmp7_);
#line 104 "WorkspaceManager.vala"
		if (_tmp8_) {
#line 450 "WorkspaceManager.c"
			GeeIterator* _tmp9_;
#line 105 "WorkspaceManager.vala"
			_tmp9_ = it;
#line 105 "WorkspaceManager.vala"
			gee_iterator_remove (_tmp9_);
#line 456 "WorkspaceManager.c"
		}
	}
#line 98 "WorkspaceManager.vala"
	_g_object_unref0 (it);
#line 461 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self,
                                           MetaScreen* screen,
                                           gint from,
                                           gint to,
                                           MetaMotionDirection direction)
{
	MetaWorkspace* prev_workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWorkspace* _tmp3_;
#line 109 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 109 "WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 111 "WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 112 "WorkspaceManager.vala"
		return;
#line 484 "WorkspaceManager.c"
	}
#line 115 "WorkspaceManager.vala"
	_tmp0_ = meta_screen_get_workspace_by_index (screen, from);
#line 115 "WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 115 "WorkspaceManager.vala"
	prev_workspace = _tmp1_;
#line 116 "WorkspaceManager.vala"
	_tmp3_ = prev_workspace;
#line 116 "WorkspaceManager.vala"
	if (gala_utils_get_n_windows (_tmp3_) < ((guint) 1)) {
#line 117 "WorkspaceManager.vala"
		_tmp2_ = from != (meta_screen_get_n_workspaces (screen) - 1);
#line 498 "WorkspaceManager.c"
	} else {
#line 116 "WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 502 "WorkspaceManager.c"
	}
#line 116 "WorkspaceManager.vala"
	if (_tmp2_) {
#line 506 "WorkspaceManager.c"
		MetaWorkspace* _tmp4_;
#line 118 "WorkspaceManager.vala"
		_tmp4_ = prev_workspace;
#line 118 "WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp4_);
#line 512 "WorkspaceManager.c"
	}
#line 109 "WorkspaceManager.vala"
	_g_object_unref0 (prev_workspace);
#line 516 "WorkspaceManager.c"
}

static void
gala_workspace_manager_window_added (GalaWorkspaceManager* self,
                                     MetaWorkspace* workspace,
                                     MetaWindow* window)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	GalaBehaviorSettings* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	MetaWindowType _tmp22_;
	MetaWindowType _tmp23_;
#line 122 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 122 "WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 124 "WorkspaceManager.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 124 "WorkspaceManager.vala"
	screen = _tmp0_;
#line 127 "WorkspaceManager.vala"
	_tmp1_ = gala_behavior_settings_get_default ();
#line 127 "WorkspaceManager.vala"
	_tmp2_ = gala_behavior_settings_get_auto_focus_windows (_tmp1_, &_tmp3_);
#line 127 "WorkspaceManager.vala"
	_tmp2__length1 = _tmp3_;
#line 127 "WorkspaceManager.vala"
	_tmp4_ = _tmp2_;
#line 127 "WorkspaceManager.vala"
	_tmp4__length1 = _tmp2__length1;
#line 557 "WorkspaceManager.c"
	{
		gchar** w_collection = NULL;
		gint w_collection_length1 = 0;
		gint _w_collection_size_ = 0;
		gint w_it = 0;
#line 127 "WorkspaceManager.vala"
		w_collection = _tmp4_;
#line 127 "WorkspaceManager.vala"
		w_collection_length1 = _tmp4__length1;
#line 127 "WorkspaceManager.vala"
		for (w_it = 0; w_it < w_collection_length1; w_it = w_it + 1) {
#line 569 "WorkspaceManager.c"
			gchar* _tmp5_;
			gchar* w = NULL;
#line 127 "WorkspaceManager.vala"
			_tmp5_ = g_strdup (w_collection[w_it]);
#line 127 "WorkspaceManager.vala"
			w = _tmp5_;
#line 576 "WorkspaceManager.c"
			{
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
#line 128 "WorkspaceManager.vala"
				_tmp8_ = w;
#line 128 "WorkspaceManager.vala"
				_tmp9_ = meta_window_get_wm_class (window);
#line 128 "WorkspaceManager.vala"
				_tmp10_ = _tmp9_;
#line 128 "WorkspaceManager.vala"
				if (g_strcmp0 (_tmp8_, _tmp10_) == 0) {
#line 591 "WorkspaceManager.c"
					MetaWindowType _tmp11_;
					MetaWindowType _tmp12_;
#line 128 "WorkspaceManager.vala"
					_tmp11_ = meta_window_get_window_type (window);
#line 128 "WorkspaceManager.vala"
					_tmp12_ = _tmp11_;
#line 128 "WorkspaceManager.vala"
					_tmp7_ = _tmp12_ == META_WINDOW_NORMAL;
#line 600 "WorkspaceManager.c"
				} else {
#line 128 "WorkspaceManager.vala"
					_tmp7_ = FALSE;
#line 604 "WorkspaceManager.c"
				}
#line 128 "WorkspaceManager.vala"
				if (_tmp7_) {
#line 129 "WorkspaceManager.vala"
					_tmp6_ = meta_window_showing_on_its_workspace (window);
#line 610 "WorkspaceManager.c"
				} else {
#line 128 "WorkspaceManager.vala"
					_tmp6_ = FALSE;
#line 614 "WorkspaceManager.c"
				}
#line 128 "WorkspaceManager.vala"
				if (_tmp6_) {
#line 618 "WorkspaceManager.c"
					MetaScreen* _tmp13_;
					MetaDisplay* _tmp14_;
#line 130 "WorkspaceManager.vala"
					_tmp13_ = screen;
#line 130 "WorkspaceManager.vala"
					_tmp14_ = meta_screen_get_display (_tmp13_);
#line 130 "WorkspaceManager.vala"
					meta_window_activate (window, meta_display_get_current_time (_tmp14_));
#line 131 "WorkspaceManager.vala"
					_g_free0 (w);
#line 131 "WorkspaceManager.vala"
					break;
#line 631 "WorkspaceManager.c"
				}
#line 127 "WorkspaceManager.vala"
				_g_free0 (w);
#line 635 "WorkspaceManager.c"
			}
		}
	}
#line 135 "WorkspaceManager.vala"
	if (workspace == NULL) {
#line 135 "WorkspaceManager.vala"
		_tmp16_ = TRUE;
#line 643 "WorkspaceManager.c"
	} else {
#line 135 "WorkspaceManager.vala"
		_tmp16_ = !meta_prefs_get_dynamic_workspaces ();
#line 647 "WorkspaceManager.c"
	}
#line 135 "WorkspaceManager.vala"
	if (_tmp16_) {
#line 135 "WorkspaceManager.vala"
		_tmp15_ = TRUE;
#line 653 "WorkspaceManager.c"
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 136 "WorkspaceManager.vala"
		g_object_get (window, "on-all-workspaces", &_tmp17_, NULL);
#line 136 "WorkspaceManager.vala"
		_tmp18_ = _tmp17_;
#line 136 "WorkspaceManager.vala"
		_tmp15_ = _tmp18_;
#line 663 "WorkspaceManager.c"
	}
#line 135 "WorkspaceManager.vala"
	if (_tmp15_) {
#line 137 "WorkspaceManager.vala"
		return;
#line 669 "WorkspaceManager.c"
	}
#line 139 "WorkspaceManager.vala"
	_tmp22_ = meta_window_get_window_type (window);
#line 139 "WorkspaceManager.vala"
	_tmp23_ = _tmp22_;
#line 139 "WorkspaceManager.vala"
	if (_tmp23_ == META_WINDOW_NORMAL) {
#line 139 "WorkspaceManager.vala"
		_tmp21_ = TRUE;
#line 679 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp24_;
		MetaWindowType _tmp25_;
#line 140 "WorkspaceManager.vala"
		_tmp24_ = meta_window_get_window_type (window);
#line 140 "WorkspaceManager.vala"
		_tmp25_ = _tmp24_;
#line 140 "WorkspaceManager.vala"
		_tmp21_ = _tmp25_ == META_WINDOW_DIALOG;
#line 689 "WorkspaceManager.c"
	}
#line 139 "WorkspaceManager.vala"
	if (_tmp21_) {
#line 139 "WorkspaceManager.vala"
		_tmp20_ = TRUE;
#line 695 "WorkspaceManager.c"
	} else {
		MetaWindowType _tmp26_;
		MetaWindowType _tmp27_;
#line 141 "WorkspaceManager.vala"
		_tmp26_ = meta_window_get_window_type (window);
#line 141 "WorkspaceManager.vala"
		_tmp27_ = _tmp26_;
#line 141 "WorkspaceManager.vala"
		_tmp20_ = _tmp27_ == META_WINDOW_MODAL_DIALOG;
#line 705 "WorkspaceManager.c"
	}
#line 139 "WorkspaceManager.vala"
	if (_tmp20_) {
#line 709 "WorkspaceManager.c"
		MetaScreen* _tmp28_;
#line 142 "WorkspaceManager.vala"
		_tmp28_ = screen;
#line 142 "WorkspaceManager.vala"
		_tmp19_ = meta_workspace_index (workspace) == (meta_screen_get_n_workspaces (_tmp28_) - 1);
#line 715 "WorkspaceManager.c"
	} else {
#line 139 "WorkspaceManager.vala"
		_tmp19_ = FALSE;
#line 719 "WorkspaceManager.c"
	}
#line 139 "WorkspaceManager.vala"
	if (_tmp19_) {
#line 143 "WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 725 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_removed (GalaWorkspaceManager* self,
                                       MetaWorkspace* workspace,
                                       MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
	MetaScreen* screen = NULL;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	MetaWindowType _tmp4_;
	MetaWindowType _tmp5_;
	gint index = 0;
	MetaScreen* _tmp10_;
	GList* _tmp11_;
	gboolean is_active_workspace = FALSE;
	MetaScreen* _tmp12_;
	MetaWorkspace* _tmp13_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
#line 146 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 146 "WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 148 "WorkspaceManager.vala"
	if (workspace == NULL) {
#line 148 "WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 759 "WorkspaceManager.c"
	} else {
#line 148 "WorkspaceManager.vala"
		_tmp0_ = !meta_prefs_get_dynamic_workspaces ();
#line 763 "WorkspaceManager.c"
	}
#line 148 "WorkspaceManager.vala"
	if (_tmp0_) {
#line 149 "WorkspaceManager.vala"
		return;
#line 769 "WorkspaceManager.c"
	}
#line 151 "WorkspaceManager.vala"
	_tmp1_ = meta_workspace_get_screen (workspace);
#line 151 "WorkspaceManager.vala"
	screen = _tmp1_;
#line 153 "WorkspaceManager.vala"
	_tmp4_ = meta_window_get_window_type (window);
#line 153 "WorkspaceManager.vala"
	_tmp5_ = _tmp4_;
#line 153 "WorkspaceManager.vala"
	if (_tmp5_ != META_WINDOW_NORMAL) {
#line 781 "WorkspaceManager.c"
		MetaWindowType _tmp6_;
		MetaWindowType _tmp7_;
#line 154 "WorkspaceManager.vala"
		_tmp6_ = meta_window_get_window_type (window);
#line 154 "WorkspaceManager.vala"
		_tmp7_ = _tmp6_;
#line 154 "WorkspaceManager.vala"
		_tmp3_ = _tmp7_ != META_WINDOW_DIALOG;
#line 790 "WorkspaceManager.c"
	} else {
#line 153 "WorkspaceManager.vala"
		_tmp3_ = FALSE;
#line 794 "WorkspaceManager.c"
	}
#line 153 "WorkspaceManager.vala"
	if (_tmp3_) {
#line 798 "WorkspaceManager.c"
		MetaWindowType _tmp8_;
		MetaWindowType _tmp9_;
#line 155 "WorkspaceManager.vala"
		_tmp8_ = meta_window_get_window_type (window);
#line 155 "WorkspaceManager.vala"
		_tmp9_ = _tmp8_;
#line 155 "WorkspaceManager.vala"
		_tmp2_ = _tmp9_ != META_WINDOW_MODAL_DIALOG;
#line 807 "WorkspaceManager.c"
	} else {
#line 153 "WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 811 "WorkspaceManager.c"
	}
#line 153 "WorkspaceManager.vala"
	if (_tmp2_) {
#line 156 "WorkspaceManager.vala"
		return;
#line 817 "WorkspaceManager.c"
	}
#line 158 "WorkspaceManager.vala"
	_tmp10_ = screen;
#line 158 "WorkspaceManager.vala"
	_tmp11_ = meta_screen_get_workspaces (_tmp10_);
#line 158 "WorkspaceManager.vala"
	index = g_list_index (_tmp11_, workspace);
#line 160 "WorkspaceManager.vala"
	if (index < 0) {
#line 161 "WorkspaceManager.vala"
		return;
#line 829 "WorkspaceManager.c"
	}
#line 163 "WorkspaceManager.vala"
	_tmp12_ = screen;
#line 163 "WorkspaceManager.vala"
	_tmp13_ = meta_screen_get_active_workspace (_tmp12_);
#line 163 "WorkspaceManager.vala"
	is_active_workspace = workspace == _tmp13_;
#line 167 "WorkspaceManager.vala"
	if (!is_active_workspace) {
#line 167 "WorkspaceManager.vala"
		_tmp17_ = TRUE;
#line 841 "WorkspaceManager.c"
	} else {
		GalaWindowManager* _tmp18_;
#line 167 "WorkspaceManager.vala"
		_tmp18_ = self->priv->_wm;
#line 167 "WorkspaceManager.vala"
		_tmp17_ = gala_window_manager_is_modal (_tmp18_);
#line 848 "WorkspaceManager.c"
	}
#line 167 "WorkspaceManager.vala"
	if (_tmp17_) {
#line 168 "WorkspaceManager.vala"
		_tmp16_ = self->priv->remove_freeze_count < 1;
#line 854 "WorkspaceManager.c"
	} else {
#line 167 "WorkspaceManager.vala"
		_tmp16_ = FALSE;
#line 858 "WorkspaceManager.c"
	}
#line 167 "WorkspaceManager.vala"
	if (_tmp16_) {
#line 169 "WorkspaceManager.vala"
		_tmp15_ = gala_utils_get_n_windows (workspace) < ((guint) 1);
#line 864 "WorkspaceManager.c"
	} else {
#line 167 "WorkspaceManager.vala"
		_tmp15_ = FALSE;
#line 868 "WorkspaceManager.c"
	}
#line 167 "WorkspaceManager.vala"
	if (_tmp15_) {
#line 872 "WorkspaceManager.c"
		MetaScreen* _tmp19_;
#line 170 "WorkspaceManager.vala"
		_tmp19_ = screen;
#line 170 "WorkspaceManager.vala"
		_tmp14_ = index != (meta_screen_get_n_workspaces (_tmp19_) - 1);
#line 878 "WorkspaceManager.c"
	} else {
#line 167 "WorkspaceManager.vala"
		_tmp14_ = FALSE;
#line 882 "WorkspaceManager.c"
	}
#line 167 "WorkspaceManager.vala"
	if (_tmp14_) {
#line 171 "WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, workspace);
#line 888 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                               MetaScreen* screen,
                                               gint monitor,
                                               MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 175 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 175 "WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 175 "WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 177 "WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 178 "WorkspaceManager.vala"
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
#line 909 "WorkspaceManager.c"
	} else {
#line 177 "WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 913 "WorkspaceManager.c"
	}
#line 177 "WorkspaceManager.vala"
	if (_tmp0_) {
#line 917 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 179 "WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 179 "WorkspaceManager.vala"
		gala_workspace_manager_window_added (self, _tmp1_, window);
#line 923 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                            MetaScreen* screen,
                                            gint monitor,
                                            MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 182 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 182 "WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 182 "WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 184 "WorkspaceManager.vala"
	if (gala_internal_utils_workspaces_only_on_primary ()) {
#line 185 "WorkspaceManager.vala"
		_tmp0_ = monitor == meta_screen_get_primary_monitor (screen);
#line 944 "WorkspaceManager.c"
	} else {
#line 184 "WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 948 "WorkspaceManager.c"
	}
#line 184 "WorkspaceManager.vala"
	if (_tmp0_) {
#line 952 "WorkspaceManager.c"
		MetaWorkspace* _tmp1_;
#line 186 "WorkspaceManager.vala"
		_tmp1_ = meta_window_get_workspace (window);
#line 186 "WorkspaceManager.vala"
		gala_workspace_manager_window_removed (self, _tmp1_, window);
#line 958 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self,
                                       MetaPreference pref)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 189 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 191 "WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 191 "WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 191 "WorkspaceManager.vala"
	screen = _tmp1_;
#line 193 "WorkspaceManager.vala"
	if (pref == META_PREF_DYNAMIC_WORKSPACES) {
#line 193 "WorkspaceManager.vala"
		_tmp2_ = meta_prefs_get_dynamic_workspaces ();
#line 982 "WorkspaceManager.c"
	} else {
#line 193 "WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 986 "WorkspaceManager.c"
	}
#line 193 "WorkspaceManager.vala"
	if (_tmp2_) {
#line 990 "WorkspaceManager.c"
		MetaScreen* _tmp3_;
		MetaScreen* _tmp4_;
		MetaWorkspace* _tmp5_;
#line 195 "WorkspaceManager.vala"
		_tmp3_ = screen;
#line 195 "WorkspaceManager.vala"
		_tmp4_ = screen;
#line 195 "WorkspaceManager.vala"
		_tmp5_ = meta_screen_get_workspace_by_index (_tmp3_, meta_screen_get_n_workspaces (_tmp4_) - 1);
#line 195 "WorkspaceManager.vala"
		if (gala_utils_get_n_windows (_tmp5_) > ((guint) 0)) {
#line 196 "WorkspaceManager.vala"
			gala_workspace_manager_append_workspace (self);
#line 1004 "WorkspaceManager.c"
		}
	}
}

static void
gala_workspace_manager_append_workspace (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
#line 200 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 202 "WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 202 "WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 202 "WorkspaceManager.vala"
	screen = _tmp1_;
#line 204 "WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (screen);
#line 204 "WorkspaceManager.vala"
	meta_screen_append_new_workspace (screen, FALSE, meta_display_get_current_time (_tmp2_));
#line 1028 "WorkspaceManager.c"
}

/**
 * Make sure we switch to a different workspace and remove the given one
 *
 * @param workspace The workspace to remove
 */
static void
gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self,
                                         MetaWorkspace* workspace)
{
	MetaScreen* screen = NULL;
	MetaScreen* _tmp0_;
	guint32 time = 0U;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	GeeLinkedList* _tmp14_;
	guint _tmp15_;
	guint _tmp16_;
	GeeLinkedList* _tmp17_;
	MetaScreen* _tmp18_;
#line 212 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 212 "WorkspaceManager.vala"
	g_return_if_fail (workspace != NULL);
#line 214 "WorkspaceManager.vala"
	_tmp0_ = meta_workspace_get_screen (workspace);
#line 214 "WorkspaceManager.vala"
	screen = _tmp0_;
#line 216 "WorkspaceManager.vala"
	_tmp1_ = screen;
#line 216 "WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 216 "WorkspaceManager.vala"
	time = meta_display_get_current_time (_tmp2_);
#line 218 "WorkspaceManager.vala"
	_tmp3_ = screen;
#line 218 "WorkspaceManager.vala"
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
#line 218 "WorkspaceManager.vala"
	if (workspace == _tmp4_) {
#line 1072 "WorkspaceManager.c"
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp5_;
		MetaWorkspace* _tmp6_;
		gboolean _tmp7_ = FALSE;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp12_;
#line 219 "WorkspaceManager.vala"
		next = NULL;
#line 221 "WorkspaceManager.vala"
		_tmp5_ = meta_workspace_get_neighbor (workspace, META_MOTION_LEFT);
#line 221 "WorkspaceManager.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 221 "WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 221 "WorkspaceManager.vala"
		next = _tmp6_;
#line 223 "WorkspaceManager.vala"
		_tmp8_ = next;
#line 223 "WorkspaceManager.vala"
		if (_tmp8_ == workspace) {
#line 223 "WorkspaceManager.vala"
			_tmp7_ = TRUE;
#line 1095 "WorkspaceManager.c"
		} else {
			MetaWorkspace* _tmp9_;
#line 223 "WorkspaceManager.vala"
			_tmp9_ = next;
#line 223 "WorkspaceManager.vala"
			_tmp7_ = _tmp9_ == NULL;
#line 1102 "WorkspaceManager.c"
		}
#line 223 "WorkspaceManager.vala"
		if (_tmp7_) {
#line 1106 "WorkspaceManager.c"
			MetaWorkspace* _tmp10_;
			MetaWorkspace* _tmp11_;
#line 224 "WorkspaceManager.vala"
			_tmp10_ = meta_workspace_get_neighbor (workspace, META_MOTION_RIGHT);
#line 224 "WorkspaceManager.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 224 "WorkspaceManager.vala"
			_g_object_unref0 (next);
#line 224 "WorkspaceManager.vala"
			next = _tmp11_;
#line 1117 "WorkspaceManager.c"
		}
#line 226 "WorkspaceManager.vala"
		_tmp12_ = next;
#line 226 "WorkspaceManager.vala"
		if (_tmp12_ != NULL) {
#line 1123 "WorkspaceManager.c"
			MetaWorkspace* _tmp13_;
#line 227 "WorkspaceManager.vala"
			_tmp13_ = next;
#line 227 "WorkspaceManager.vala"
			meta_workspace_activate (_tmp13_, time);
#line 1129 "WorkspaceManager.c"
		}
#line 218 "WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 1133 "WorkspaceManager.c"
	}
#line 231 "WorkspaceManager.vala"
	_tmp14_ = self->priv->workspaces_marked_removed;
#line 231 "WorkspaceManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp14_, workspace)) {
#line 232 "WorkspaceManager.vala"
		return;
#line 1141 "WorkspaceManager.c"
	}
#line 235 "WorkspaceManager.vala"
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp15_, NULL, FALSE);
#line 235 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
#line 236 "WorkspaceManager.vala"
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp16_, NULL, FALSE);
#line 236 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (workspace, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
#line 238 "WorkspaceManager.vala"
	_tmp17_ = self->priv->workspaces_marked_removed;
#line 238 "WorkspaceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, workspace);
#line 240 "WorkspaceManager.vala"
	_tmp18_ = screen;
#line 240 "WorkspaceManager.vala"
	meta_screen_remove_workspace (_tmp18_, workspace, time);
#line 1159 "WorkspaceManager.c"
}

/**
 * Temporarily disables removing workspaces when they are empty
 */
void
gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 246 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 248 "WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 248 "WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ + 1;
#line 1175 "WorkspaceManager.c"
}

/**
 * Undo the effect of freeze_remove()
 */
void
gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self)
{
	gint _tmp0_;
#line 254 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 256 "WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 256 "WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ - 1;
#line 258 "WorkspaceManager.vala"
	_vala_assert (self->priv->remove_freeze_count >= 0, "remove_freeze_count >= 0");
#line 1193 "WorkspaceManager.c"
}

/**
 * If workspaces are dynamic, checks if there are empty workspaces that should
 * be removed. Particularily useful in conjunction with freeze/thaw_remove to
 * cleanup after an operation that required stable workspace/window indices
 */
void
gala_workspace_manager_cleanup (GalaWorkspaceManager* self)
{
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	gint last_index = 0;
	MetaScreen* _tmp3_;
	MetaScreen* _tmp4_;
	GList* _tmp5_;
#line 266 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 268 "WorkspaceManager.vala"
	if (!meta_prefs_get_dynamic_workspaces ()) {
#line 269 "WorkspaceManager.vala"
		return;
#line 1218 "WorkspaceManager.c"
	}
#line 271 "WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 271 "WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 271 "WorkspaceManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 271 "WorkspaceManager.vala"
	screen = _tmp2_;
#line 272 "WorkspaceManager.vala"
	_tmp3_ = screen;
#line 272 "WorkspaceManager.vala"
	last_index = meta_screen_get_n_workspaces (_tmp3_) - 1;
#line 274 "WorkspaceManager.vala"
	_tmp4_ = screen;
#line 274 "WorkspaceManager.vala"
	_tmp5_ = meta_screen_get_workspaces (_tmp4_);
#line 1236 "WorkspaceManager.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 274 "WorkspaceManager.vala"
		workspace_collection = _tmp5_;
#line 274 "WorkspaceManager.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1244 "WorkspaceManager.c"
			MetaWorkspace* _tmp6_;
			MetaWorkspace* workspace = NULL;
#line 274 "WorkspaceManager.vala"
			_tmp6_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 274 "WorkspaceManager.vala"
			workspace = _tmp6_;
#line 1251 "WorkspaceManager.c"
			{
				gboolean _tmp7_ = FALSE;
				MetaWorkspace* _tmp8_;
#line 275 "WorkspaceManager.vala"
				_tmp8_ = workspace;
#line 275 "WorkspaceManager.vala"
				if (gala_utils_get_n_windows (_tmp8_) < ((guint) 1)) {
#line 1259 "WorkspaceManager.c"
					MetaWorkspace* _tmp9_;
#line 276 "WorkspaceManager.vala"
					_tmp9_ = workspace;
#line 276 "WorkspaceManager.vala"
					_tmp7_ = meta_workspace_index (_tmp9_) != last_index;
#line 1265 "WorkspaceManager.c"
				} else {
#line 275 "WorkspaceManager.vala"
					_tmp7_ = FALSE;
#line 1269 "WorkspaceManager.c"
				}
#line 275 "WorkspaceManager.vala"
				if (_tmp7_) {
#line 1273 "WorkspaceManager.c"
					MetaWorkspace* _tmp10_;
#line 277 "WorkspaceManager.vala"
					_tmp10_ = workspace;
#line 277 "WorkspaceManager.vala"
					gala_workspace_manager_remove_workspace (self, _tmp10_);
#line 1279 "WorkspaceManager.c"
				}
#line 274 "WorkspaceManager.vala"
				_g_object_unref0 (workspace);
#line 1283 "WorkspaceManager.c"
			}
		}
	}
#line 266 "WorkspaceManager.vala"
	_g_object_unref0 (screen);
#line 1289 "WorkspaceManager.c"
}

GalaWindowManager*
gala_workspace_manager_get_wm (GalaWorkspaceManager* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 39 "WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 39 "WorkspaceManager.vala"
	result = _tmp0_;
#line 39 "WorkspaceManager.vala"
	return result;
#line 1305 "WorkspaceManager.c"
}

static void
gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                               GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 39 "WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "WorkspaceManager.vala"
	old_value = gala_workspace_manager_get_wm (self);
#line 39 "WorkspaceManager.vala"
	if (old_value != value) {
#line 1319 "WorkspaceManager.c"
		GalaWindowManager* _tmp0_;
#line 39 "WorkspaceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "WorkspaceManager.vala"
		_g_object_unref0 (self->priv->_wm);
#line 39 "WorkspaceManager.vala"
		self->priv->_wm = _tmp0_;
#line 39 "WorkspaceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
#line 1329 "WorkspaceManager.c"
	}
}

static GObject *
gala_workspace_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GeeLinkedList* _tmp2_;
	MetaScreen* _tmp8_;
	MetaScreen* _tmp9_;
	MetaScreen* _tmp10_;
	MetaScreen* _tmp11_;
	MetaScreen* _tmp12_;
	gboolean _tmp13_ = FALSE;
#line 49 "WorkspaceManager.vala"
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
#line 49 "WorkspaceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 49 "WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 51 "WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 51 "WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 51 "WorkspaceManager.vala"
	screen = _tmp1_;
#line 53 "WorkspaceManager.vala"
	_tmp2_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 53 "WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 53 "WorkspaceManager.vala"
	self->priv->workspaces_marked_removed = _tmp2_;
#line 55 "WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1371 "WorkspaceManager.c"
		MetaScreen* _tmp3_;
#line 56 "WorkspaceManager.vala"
		_tmp3_ = screen;
#line 56 "WorkspaceManager.vala"
		meta_screen_override_workspace_layout (_tmp3_, META_SCREEN_TOPLEFT, FALSE, 1, -1);
#line 1377 "WorkspaceManager.c"
	}
	{
		gint i = 0;
#line 58 "WorkspaceManager.vala"
		i = 0;
#line 1383 "WorkspaceManager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 58 "WorkspaceManager.vala"
			_tmp4_ = TRUE;
#line 58 "WorkspaceManager.vala"
			while (TRUE) {
#line 1390 "WorkspaceManager.c"
				MetaScreen* _tmp6_;
				MetaScreen* _tmp7_;
#line 58 "WorkspaceManager.vala"
				if (!_tmp4_) {
#line 1395 "WorkspaceManager.c"
					gint _tmp5_;
#line 58 "WorkspaceManager.vala"
					_tmp5_ = i;
#line 58 "WorkspaceManager.vala"
					i = _tmp5_ + 1;
#line 1401 "WorkspaceManager.c"
				}
#line 58 "WorkspaceManager.vala"
				_tmp4_ = FALSE;
#line 58 "WorkspaceManager.vala"
				_tmp6_ = screen;
#line 58 "WorkspaceManager.vala"
				if (!(i < meta_screen_get_n_workspaces (_tmp6_))) {
#line 58 "WorkspaceManager.vala"
					break;
#line 1411 "WorkspaceManager.c"
				}
#line 59 "WorkspaceManager.vala"
				_tmp7_ = screen;
#line 59 "WorkspaceManager.vala"
				gala_workspace_manager_workspace_added (self, _tmp7_, i);
#line 1417 "WorkspaceManager.c"
			}
		}
	}
#line 61 "WorkspaceManager.vala"
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 63 "WorkspaceManager.vala"
	_tmp8_ = screen;
#line 63 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp8_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self, G_CONNECT_AFTER);
#line 64 "WorkspaceManager.vala"
	_tmp9_ = screen;
#line 64 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp9_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self, 0);
#line 65 "WorkspaceManager.vala"
	_tmp10_ = screen;
#line 65 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp10_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self, G_CONNECT_AFTER);
#line 66 "WorkspaceManager.vala"
	_tmp11_ = screen;
#line 66 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp11_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self, 0);
#line 67 "WorkspaceManager.vala"
	_tmp12_ = screen;
#line 67 "WorkspaceManager.vala"
	g_signal_connect_object (_tmp12_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self, 0);
#line 70 "WorkspaceManager.vala"
	if (meta_prefs_get_dynamic_workspaces ()) {
#line 1445 "WorkspaceManager.c"
		MetaScreen* _tmp14_;
		MetaScreen* _tmp15_;
		MetaWorkspace* _tmp16_;
#line 71 "WorkspaceManager.vala"
		_tmp14_ = screen;
#line 71 "WorkspaceManager.vala"
		_tmp15_ = screen;
#line 71 "WorkspaceManager.vala"
		_tmp16_ = meta_screen_get_workspace_by_index (_tmp14_, meta_screen_get_n_workspaces (_tmp15_) - 1);
#line 71 "WorkspaceManager.vala"
		_tmp13_ = gala_utils_get_n_windows (_tmp16_) > ((guint) 0);
#line 1457 "WorkspaceManager.c"
	} else {
#line 70 "WorkspaceManager.vala"
		_tmp13_ = FALSE;
#line 1461 "WorkspaceManager.c"
	}
#line 70 "WorkspaceManager.vala"
	if (_tmp13_) {
#line 72 "WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 1467 "WorkspaceManager.c"
	}
#line 49 "WorkspaceManager.vala"
	return obj;
#line 1471 "WorkspaceManager.c"
}

static void
gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass,
                                   gpointer klass_data)
{
#line 23 "WorkspaceManager.vala"
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
#line 23 "WorkspaceManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaWorkspaceManager_private_offset);
#line 23 "WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
#line 23 "WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
#line 23 "WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
#line 23 "WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
#line 23 "WorkspaceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1492 "WorkspaceManager.c"
}

static void
gala_workspace_manager_instance_init (GalaWorkspaceManager * self,
                                      gpointer klass)
{
#line 23 "WorkspaceManager.vala"
	self->priv = gala_workspace_manager_get_instance_private (self);
#line 42 "WorkspaceManager.vala"
	self->priv->remove_freeze_count = 0;
#line 1503 "WorkspaceManager.c"
}

static void
gala_workspace_manager_finalize (GObject * obj)
{
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	guint _tmp3_;
	MetaScreen* _tmp4_;
	guint _tmp5_;
	MetaScreen* _tmp6_;
	guint _tmp7_;
	MetaScreen* _tmp8_;
	guint _tmp9_;
	MetaScreen* _tmp10_;
	guint _tmp11_;
#line 23 "WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 77 "WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 77 "WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 77 "WorkspaceManager.vala"
	screen = _tmp1_;
#line 79 "WorkspaceManager.vala"
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 81 "WorkspaceManager.vala"
	_tmp2_ = screen;
#line 81 "WorkspaceManager.vala"
	g_signal_parse_name ("workspace-added", meta_screen_get_type (), &_tmp3_, NULL, FALSE);
#line 81 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self);
#line 82 "WorkspaceManager.vala"
	_tmp4_ = screen;
#line 82 "WorkspaceManager.vala"
	g_signal_parse_name ("workspace-switched", meta_screen_get_type (), &_tmp5_, NULL, FALSE);
#line 82 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self);
#line 83 "WorkspaceManager.vala"
	_tmp6_ = screen;
#line 83 "WorkspaceManager.vala"
	g_signal_parse_name ("workspace-removed", meta_screen_get_type (), &_tmp7_, NULL, FALSE);
#line 83 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self);
#line 84 "WorkspaceManager.vala"
	_tmp8_ = screen;
#line 84 "WorkspaceManager.vala"
	g_signal_parse_name ("window-entered-monitor", meta_screen_get_type (), &_tmp9_, NULL, FALSE);
#line 84 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self);
#line 85 "WorkspaceManager.vala"
	_tmp10_ = screen;
#line 85 "WorkspaceManager.vala"
	g_signal_parse_name ("window-left-monitor", meta_screen_get_type (), &_tmp11_, NULL, FALSE);
#line 85 "WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self);
#line 39 "WorkspaceManager.vala"
	_g_object_unref0 (self->priv->_wm);
#line 41 "WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 23 "WorkspaceManager.vala"
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
#line 1569 "WorkspaceManager.c"
}

static GType
gala_workspace_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
	GType gala_workspace_manager_type_id;
	gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
	GalaWorkspaceManager_private_offset = g_type_add_instance_private (gala_workspace_manager_type_id, sizeof (GalaWorkspaceManagerPrivate));
	return gala_workspace_manager_type_id;
}

GType
gala_workspace_manager_get_type (void)
{
	static volatile gsize gala_workspace_manager_type_id__once = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__once)) {
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = gala_workspace_manager_get_type_once ();
		g_once_init_leave (&gala_workspace_manager_type_id__once, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__once;
}

static void
_vala_gala_workspace_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 23 "WorkspaceManager.vala"
	switch (property_id) {
#line 23 "WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 23 "WorkspaceManager.vala"
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
#line 23 "WorkspaceManager.vala"
		break;
#line 1610 "WorkspaceManager.c"
		default:
#line 23 "WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "WorkspaceManager.vala"
		break;
#line 1616 "WorkspaceManager.c"
	}
}

static void
_vala_gala_workspace_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 23 "WorkspaceManager.vala"
	switch (property_id) {
#line 23 "WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 23 "WorkspaceManager.vala"
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
#line 23 "WorkspaceManager.vala"
		break;
#line 1636 "WorkspaceManager.c"
		default:
#line 23 "WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "WorkspaceManager.vala"
		break;
#line 1642 "WorkspaceManager.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 22 "PluginManager.vala"
	if (mem && byte_size != 0) {
#line 22 "PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 22 "PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1657 "WorkspaceManager.c"
	} else {
#line 22 "PluginManager.vala"
		new_mem = NULL;
#line 1661 "WorkspaceManager.c"
	}
#line 22 "PluginManager.vala"
	return new_mem;
#line 1665 "WorkspaceManager.c"
}

